/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(typeof dojo=="undefined"){
var dj_global=this;
var dj_currentContext=this;
function dj_undef(_1,_2){
return (typeof (_2||dj_currentContext)[_1]=="undefined");
}
if(dj_undef("djConfig",this)){
var djConfig={};
}
if(dj_undef("dojo",this)){
var dojo={};
}
dojo.global=function(){
return dj_currentContext;
};
dojo.locale=djConfig.locale;
dojo.version={major:0,minor:4,patch:0,flag:"",revision:Number("$Rev: 6258 $".match(/[0-9]+/)[0]),toString:function(){
with(dojo.version){
return major+"."+minor+"."+patch+flag+" ("+revision+")";
}
}};
dojo.evalProp=function(_3,_4,_5){
if((!_4)||(!_3)){
return undefined;
}
if(!dj_undef(_3,_4)){
return _4[_3];
}
return (_5?(_4[_3]={}):undefined);
};
dojo.parseObjPath=function(_6,_7,_8){
var _9=(_7||dojo.global());
var _a=_6.split(".");
var _b=_a.pop();
for(var i=0,l=_a.length;i<l&&_9;i++){
_9=dojo.evalProp(_a[i],_9,_8);
}
return {obj:_9,prop:_b};
};
dojo.evalObjPath=function(_e,_f){
if(typeof _e!="string"){
return dojo.global();
}
if(_e.indexOf(".")==-1){
return dojo.evalProp(_e,dojo.global(),_f);
}
var ref=dojo.parseObjPath(_e,dojo.global(),_f);
if(ref){
return dojo.evalProp(ref.prop,ref.obj,_f);
}
return null;
};
dojo.errorToString=function(_11){
if(!dj_undef("message",_11)){
return _11.message;
}else{
if(!dj_undef("description",_11)){
return _11.description;
}else{
return _11;
}
}
};
dojo.raise=function(_12,_13){
if(_13){
_12=_12+": "+dojo.errorToString(_13);
}
try{
if(djConfig.isDebug){
dojo.hostenv.println("FATAL exception raised: "+_12);
}
}
catch(e){
}
throw _13||Error(_12);
};
dojo.debug=function(){
};
dojo.debugShallow=function(obj){
};
dojo.profile={start:function(){
},end:function(){
},stop:function(){
},dump:function(){
}};
function dj_eval(_15){
return dj_global.eval?dj_global.eval(_15):eval(_15);
}
dojo.unimplemented=function(_16,_17){
var _18="'"+_16+"' not implemented";
if(_17!=null){
_18+=" "+_17;
}
dojo.raise(_18);
};
dojo.deprecated=function(_19,_1a,_1b){
var _1c="DEPRECATED: "+_19;
if(_1a){
_1c+=" "+_1a;
}
if(_1b){
_1c+=" -- will be removed in version: "+_1b;
}
dojo.debug(_1c);
};
dojo.render=(function(){
function vscaffold(_1d,_1e){
var tmp={capable:false,support:{builtin:false,plugin:false},prefixes:_1d};
for(var i=0;i<_1e.length;i++){
tmp[_1e[i]]=false;
}
return tmp;
}
return {name:"",ver:dojo.version,os:{win:false,linux:false,osx:false},html:vscaffold(["html"],["ie","opera","khtml","safari","moz"]),svg:vscaffold(["svg"],["corel","adobe","batik"]),vml:vscaffold(["vml"],["ie"]),swf:vscaffold(["Swf","Flash","Mm"],["mm"]),swt:vscaffold(["Swt"],["ibm"])};
})();
dojo.hostenv=(function(){
var _21={isDebug:false,allowQueryConfig:false,baseScriptUri:"",baseRelativePath:"",libraryScriptUri:"",iePreventClobber:false,ieClobberMinimal:true,preventBackButtonFix:true,delayMozLoadingFix:false,searchIds:[],parseWidgets:true};
if(typeof djConfig=="undefined"){
djConfig=_21;
}else{
for(var _22 in _21){
if(typeof djConfig[_22]=="undefined"){
djConfig[_22]=_21[_22];
}
}
}
return {name_:"(unset)",version_:"(unset)",getName:function(){
return this.name_;
},getVersion:function(){
return this.version_;
},getText:function(uri){
dojo.unimplemented("getText","uri="+uri);
}};
})();
dojo.hostenv.getBaseScriptUri=function(){
if(djConfig.baseScriptUri.length){
return djConfig.baseScriptUri;
}
var uri=new String(djConfig.libraryScriptUri||djConfig.baseRelativePath);
if(!uri){
dojo.raise("Nothing returned by getLibraryScriptUri(): "+uri);
}
var _25=uri.lastIndexOf("/");
djConfig.baseScriptUri=djConfig.baseRelativePath;
return djConfig.baseScriptUri;
};
(function(){
var _26={pkgFileName:"__package__",loading_modules_:{},loaded_modules_:{},addedToLoadingCount:[],removedFromLoadingCount:[],inFlightCount:0,modulePrefixes_:{dojo:{name:"dojo",value:"src"}},setModulePrefix:function(_27,_28){
this.modulePrefixes_[_27]={name:_27,value:_28};
},moduleHasPrefix:function(_29){
var mp=this.modulePrefixes_;
return Boolean(mp[_29]&&mp[_29].value);
},getModulePrefix:function(_2b){
if(this.moduleHasPrefix(_2b)){
return this.modulePrefixes_[_2b].value;
}
return _2b;
},getTextStack:[],loadUriStack:[],loadedUris:[],post_load_:false,modulesLoadedListeners:[],unloadListeners:[],loadNotifying:false};
for(var _2c in _26){
dojo.hostenv[_2c]=_26[_2c];
}
})();
dojo.hostenv.loadPath=function(_2d,_2e,cb){
var uri;
if(_2d.charAt(0)=="/"||_2d.match(/^\w+:/)){
uri=_2d;
}else{
uri=this.getBaseScriptUri()+_2d;
}
if(djConfig.cacheBust&&dojo.render.html.capable){
uri+="?"+String(djConfig.cacheBust).replace(/\W+/g,"");
}
try{
return !_2e?this.loadUri(uri,cb):this.loadUriAndCheck(uri,_2e,cb);
}
catch(e){
dojo.debug(e);
return false;
}
};
dojo.hostenv.loadUri=function(uri,cb){
if(this.loadedUris[uri]){
return true;
}
var _33=this.getText(uri,null,true);
if(!_33){
return false;
}
this.loadedUris[uri]=true;
if(cb){
_33="("+_33+")";
}
var _34=dj_eval(_33);
if(cb){
cb(_34);
}
return true;
};
dojo.hostenv.loadUriAndCheck=function(uri,_36,cb){
var ok=true;
try{
ok=this.loadUri(uri,cb);
}
catch(e){
dojo.debug("failed loading ",uri," with error: ",e);
}
return Boolean(ok&&this.findModule(_36,false));
};
dojo.loaded=function(){
};
dojo.unloaded=function(){
};
dojo.hostenv.loaded=function(){
this.loadNotifying=true;
this.post_load_=true;
var mll=this.modulesLoadedListeners;
for(var x=0;x<mll.length;x++){
mll[x]();
}
this.modulesLoadedListeners=[];
this.loadNotifying=false;
dojo.loaded();
};
dojo.hostenv.unloaded=function(){
var mll=this.unloadListeners;
while(mll.length){
(mll.pop())();
}
dojo.unloaded();
};
dojo.addOnLoad=function(obj,_3d){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.modulesLoadedListeners.push(obj);
}else{
if(arguments.length>1){
dh.modulesLoadedListeners.push(function(){
obj[_3d]();
});
}
}
if(dh.post_load_&&dh.inFlightCount==0&&!dh.loadNotifying){
dh.callLoaded();
}
};
dojo.addOnUnload=function(obj,_40){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.unloadListeners.push(obj);
}else{
if(arguments.length>1){
dh.unloadListeners.push(function(){
obj[_40]();
});
}
}
};
dojo.hostenv.modulesLoaded=function(){
if(this.post_load_){
return;
}
if(this.loadUriStack.length==0&&this.getTextStack.length==0){
if(this.inFlightCount>0){
dojo.debug("files still in flight!");
return;
}
dojo.hostenv.callLoaded();
}
};
dojo.hostenv.callLoaded=function(){
if(typeof setTimeout=="object"){
setTimeout("dojo.hostenv.loaded();",0);
}else{
dojo.hostenv.loaded();
}
};
dojo.hostenv.getModuleSymbols=function(_42){
var _43=_42.split(".");
for(var i=_43.length;i>0;i--){
var _45=_43.slice(0,i).join(".");
if((i==1)&&!this.moduleHasPrefix(_45)){
_43[0]="../"+_43[0];
}else{
var _46=this.getModulePrefix(_45);
if(_46!=_45){
_43.splice(0,i,_46);
break;
}
}
}
return _43;
};
dojo.hostenv._global_omit_module_check=false;
dojo.hostenv.loadModule=function(_47,_48,_49){
if(!_47){
return;
}
_49=this._global_omit_module_check||_49;
var _4a=this.findModule(_47,false);
if(_4a){
return _4a;
}
if(dj_undef(_47,this.loading_modules_)){
this.addedToLoadingCount.push(_47);
}
this.loading_modules_[_47]=1;
var _4b=_47.replace(/\./g,"/")+".js";
var _4c=_47.split(".");
var _4d=this.getModuleSymbols(_47);
var _4e=((_4d[0].charAt(0)!="/")&&!_4d[0].match(/^\w+:/));
var _4f=_4d[_4d.length-1];
var ok;
if(_4f=="*"){
_47=_4c.slice(0,-1).join(".");
while(_4d.length){
_4d.pop();
_4d.push(this.pkgFileName);
_4b=_4d.join("/")+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,!_49?_47:null);
if(ok){
break;
}
_4d.pop();
}
}else{
_4b=_4d.join("/")+".js";
_47=_4c.join(".");
var _51=!_49?_47:null;
ok=this.loadPath(_4b,_51);
if(!ok&&!_48){
_4d.pop();
while(_4d.length){
_4b=_4d.join("/")+".js";
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
_4d.pop();
_4b=_4d.join("/")+"/"+this.pkgFileName+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
}
}
if(!ok&&!_49){
dojo.raise("Could not load '"+_47+"'; last tried '"+_4b+"'");
}
}
if(!_49&&!this["isXDomain"]){
_4a=this.findModule(_47,false);
if(!_4a){
dojo.raise("symbol '"+_47+"' is not defined after loading '"+_4b+"'");
}
}
return _4a;
};
dojo.hostenv.startPackage=function(_52){
var _53=String(_52);
var _54=_53;
var _55=_52.split(/\./);
if(_55[_55.length-1]=="*"){
_55.pop();
_54=_55.join(".");
}
var _56=dojo.evalObjPath(_54,true);
this.loaded_modules_[_53]=_56;
this.loaded_modules_[_54]=_56;
return _56;
};
dojo.hostenv.findModule=function(_57,_58){
var lmn=String(_57);
if(this.loaded_modules_[lmn]){
return this.loaded_modules_[lmn];
}
if(_58){
dojo.raise("no loaded module named '"+_57+"'");
}
return null;
};
dojo.kwCompoundRequire=function(_5a){
var _5b=_5a["common"]||[];
var _5c=_5a[dojo.hostenv.name_]?_5b.concat(_5a[dojo.hostenv.name_]||[]):_5b.concat(_5a["default"]||[]);
for(var x=0;x<_5c.length;x++){
var _5e=_5c[x];
if(_5e.constructor==Array){
dojo.hostenv.loadModule.apply(dojo.hostenv,_5e);
}else{
dojo.hostenv.loadModule(_5e);
}
}
};
dojo.require=function(_5f){
dojo.hostenv.loadModule.apply(dojo.hostenv,arguments);
};
dojo.requireIf=function(_60,_61){
var _62=arguments[0];
if((_62===true)||(_62=="common")||(_62&&dojo.render[_62].capable)){
var _63=[];
for(var i=1;i<arguments.length;i++){
_63.push(arguments[i]);
}
dojo.require.apply(dojo,_63);
}
};
dojo.requireAfterIf=dojo.requireIf;
dojo.provide=function(_65){
return dojo.hostenv.startPackage.apply(dojo.hostenv,arguments);
};
dojo.registerModulePath=function(_66,_67){
return dojo.hostenv.setModulePrefix(_66,_67);
};
dojo.setModulePrefix=function(_68,_69){
dojo.deprecated("dojo.setModulePrefix(\""+_68+"\", \""+_69+"\")","replaced by dojo.registerModulePath","0.5");
return dojo.registerModulePath(_68,_69);
};
dojo.exists=function(obj,_6b){
var p=_6b.split(".");
for(var i=0;i<p.length;i++){
if(!obj[p[i]]){
return false;
}
obj=obj[p[i]];
}
return true;
};
dojo.hostenv.normalizeLocale=function(_6e){
return _6e?_6e.toLowerCase():dojo.locale;
};
dojo.hostenv.searchLocalePath=function(_6f,_70,_71){
_6f=dojo.hostenv.normalizeLocale(_6f);
var _72=_6f.split("-");
var _73=[];
for(var i=_72.length;i>0;i--){
_73.push(_72.slice(0,i).join("-"));
}
_73.push(false);
if(_70){
_73.reverse();
}
for(var j=_73.length-1;j>=0;j--){
var loc=_73[j]||"ROOT";
var _77=_71(loc);
if(_77){
break;
}
}
};
dojo.hostenv.localesGenerated;
dojo.hostenv.registerNlsPrefix=function(){
dojo.registerModulePath("nls","nls");
};
dojo.hostenv.preloadLocalizations=function(){
if(dojo.hostenv.localesGenerated){
dojo.hostenv.registerNlsPrefix();
function preload(_78){
_78=dojo.hostenv.normalizeLocale(_78);
dojo.hostenv.searchLocalePath(_78,true,function(loc){
for(var i=0;i<dojo.hostenv.localesGenerated.length;i++){
if(dojo.hostenv.localesGenerated[i]==loc){
dojo["require"]("nls.dojo_"+loc);
return true;
}
}
return false;
});
}
preload();
var _7b=djConfig.extraLocale||[];
for(var i=0;i<_7b.length;i++){
preload(_7b[i]);
}
}
dojo.hostenv.preloadLocalizations=function(){
};
};
dojo.requireLocalization=function(_7d,_7e,_7f){
dojo.hostenv.preloadLocalizations();
var _80=[_7d,"nls",_7e].join(".");
var _81=dojo.hostenv.findModule(_80);
if(_81){
if(djConfig.localizationComplete&&_81._built){
return;
}
var _82=dojo.hostenv.normalizeLocale(_7f).replace("-","_");
var _83=_80+"."+_82;
if(dojo.hostenv.findModule(_83)){
return;
}
}
_81=dojo.hostenv.startPackage(_80);
var _84=dojo.hostenv.getModuleSymbols(_7d);
var _85=_84.concat("nls").join("/");
var _86;
dojo.hostenv.searchLocalePath(_7f,false,function(loc){
var _88=loc.replace("-","_");
var _89=_80+"."+_88;
var _8a=false;
if(!dojo.hostenv.findModule(_89)){
dojo.hostenv.startPackage(_89);
var _8b=[_85];
if(loc!="ROOT"){
_8b.push(loc);
}
_8b.push(_7e);
var _8c=_8b.join("/")+".js";
_8a=dojo.hostenv.loadPath(_8c,null,function(_8d){
var _8e=function(){
};
_8e.prototype=_86;
_81[_88]=new _8e();
for(var j in _8d){
_81[_88][j]=_8d[j];
}
});
}else{
_8a=true;
}
if(_8a&&_81[_88]){
_86=_81[_88];
}else{
_81[_88]=_86;
}
});
};
(function(){
var _90=djConfig.extraLocale;
if(_90){
if(!_90 instanceof Array){
_90=[_90];
}
var req=dojo.requireLocalization;
dojo.requireLocalization=function(m,b,_94){
req(m,b,_94);
if(_94){
return;
}
for(var i=0;i<_90.length;i++){
req(m,b,_90[i]);
}
};
}
})();
}
if(typeof window!="undefined"){
(function(){
if(djConfig.allowQueryConfig){
var _96=document.location.toString();
var _97=_96.split("?",2);
if(_97.length>1){
var _98=_97[1];
var _99=_98.split("&");
for(var x in _99){
var sp=_99[x].split("=");
if((sp[0].length>9)&&(sp[0].substr(0,9)=="djConfig.")){
var opt=sp[0].substr(9);
try{
djConfig[opt]=eval(sp[1]);
}
catch(e){
djConfig[opt]=sp[1];
}
}
}
}
}
if(((djConfig["baseScriptUri"]=="")||(djConfig["baseRelativePath"]==""))&&(document&&document.getElementsByTagName)){
var _9d=document.getElementsByTagName("script");
var _9e=/(__package__|dojo|bootstrap1)\.js([\?\.]|$)/i;
for(var i=0;i<_9d.length;i++){
var src=_9d[i].getAttribute("src");
if(!src){
continue;
}
var m=src.match(_9e);
if(m){
var _a2=src.substring(0,m.index);
if(src.indexOf("bootstrap1")>-1){
_a2+="../";
}
if(!this["djConfig"]){
djConfig={};
}
if(djConfig["baseScriptUri"]==""){
djConfig["baseScriptUri"]=_a2;
}
if(djConfig["baseRelativePath"]==""){
djConfig["baseRelativePath"]=_a2;
}
break;
}
}
}
var dr=dojo.render;
var drh=dojo.render.html;
var drs=dojo.render.svg;
var dua=(drh.UA=navigator.userAgent);
var dav=(drh.AV=navigator.appVersion);
var t=true;
var f=false;
drh.capable=t;
drh.support.builtin=t;
dr.ver=parseFloat(drh.AV);
dr.os.mac=dav.indexOf("Macintosh")>=0;
dr.os.win=dav.indexOf("Windows")>=0;
dr.os.linux=dav.indexOf("X11")>=0;
drh.opera=dua.indexOf("Opera")>=0;
drh.khtml=(dav.indexOf("Konqueror")>=0)||(dav.indexOf("Safari")>=0);
drh.safari=dav.indexOf("Safari")>=0;
var _aa=dua.indexOf("Gecko");
drh.mozilla=drh.moz=(_aa>=0)&&(!drh.khtml);
if(drh.mozilla){
drh.geckoVersion=dua.substring(_aa+6,_aa+14);
}
drh.ie=(document.all)&&(!drh.opera);
drh.ie50=drh.ie&&dav.indexOf("MSIE 5.0")>=0;
drh.ie55=drh.ie&&dav.indexOf("MSIE 5.5")>=0;
drh.ie60=drh.ie&&dav.indexOf("MSIE 6.0")>=0;
drh.ie70=drh.ie&&dav.indexOf("MSIE 7.0")>=0;
var cm=document["compatMode"];
drh.quirks=(cm=="BackCompat")||(cm=="QuirksMode")||drh.ie55||drh.ie50;
dojo.locale=dojo.locale||(drh.ie?navigator.userLanguage:navigator.language).toLowerCase();
dr.vml.capable=drh.ie;
drs.capable=f;
drs.support.plugin=f;
drs.support.builtin=f;
var _ac=window["document"];
var tdi=_ac["implementation"];
if((tdi)&&(tdi["hasFeature"])&&(tdi.hasFeature("org.w3c.dom.svg","1.0"))){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
if(drh.safari){
var tmp=dua.split("AppleWebKit/")[1];
var ver=parseFloat(tmp.split(" ")[0]);
if(ver>=420){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
}
})();
dojo.hostenv.startPackage("dojo.hostenv");
dojo.render.name=dojo.hostenv.name_="browser";
dojo.hostenv.searchIds=[];
dojo.hostenv._XMLHTTP_PROGIDS=["Msxml2.XMLHTTP","Microsoft.XMLHTTP","Msxml2.XMLHTTP.4.0"];
dojo.hostenv.getXmlhttpObject=function(){
var _b0=null;
var _b1=null;
try{
_b0=new XMLHttpRequest();
}
catch(e){
}
if(!_b0){
for(var i=0;i<3;++i){
var _b3=dojo.hostenv._XMLHTTP_PROGIDS[i];
try{
_b0=new ActiveXObject(_b3);
}
catch(e){
_b1=e;
}
if(_b0){
dojo.hostenv._XMLHTTP_PROGIDS=[_b3];
break;
}
}
}
if(!_b0){
return dojo.raise("XMLHTTP not available",_b1);
}
return _b0;
};
dojo.hostenv._blockAsync=false;
dojo.hostenv.getText=function(uri,_b5,_b6){
if(!_b5){
this._blockAsync=true;
}
var _b7=this.getXmlhttpObject();
function isDocumentOk(_b8){
var _b9=_b8["status"];
return Boolean((!_b9)||((200<=_b9)&&(300>_b9))||(_b9==304));
}
if(_b5){
var _ba=this,_bb=null,gbl=dojo.global();
var xhr=dojo.evalObjPath("dojo.io.XMLHTTPTransport");
_b7.onreadystatechange=function(){
if(_bb){
gbl.clearTimeout(_bb);
_bb=null;
}
if(_ba._blockAsync||(xhr&&xhr._blockAsync)){
_bb=gbl.setTimeout(function(){
_b7.onreadystatechange.apply(this);
},10);
}else{
if(4==_b7.readyState){
if(isDocumentOk(_b7)){
_b5(_b7.responseText);
}
}
}
};
}
_b7.open("GET",uri,_b5?true:false);
try{
_b7.send(null);
if(_b5){
return null;
}
if(!isDocumentOk(_b7)){
var err=Error("Unable to load "+uri+" status:"+_b7.status);
err.status=_b7.status;
err.responseText=_b7.responseText;
throw err;
}
}
catch(e){
this._blockAsync=false;
if((_b6)&&(!_b5)){
return null;
}else{
throw e;
}
}
this._blockAsync=false;
return _b7.responseText;
};
dojo.hostenv.defaultDebugContainerId="dojoDebug";
dojo.hostenv._println_buffer=[];
dojo.hostenv._println_safe=false;
dojo.hostenv.println=function(_bf){
if(!dojo.hostenv._println_safe){
dojo.hostenv._println_buffer.push(_bf);
}else{
try{
var _c0=document.getElementById(djConfig.debugContainerId?djConfig.debugContainerId:dojo.hostenv.defaultDebugContainerId);
if(!_c0){
_c0=dojo.body();
}
var div=document.createElement("div");
div.appendChild(document.createTextNode(_bf));
_c0.appendChild(div);
}
catch(e){
try{
document.write("<div>"+_bf+"</div>");
}
catch(e2){
window.status=_bf;
}
}
}
};
dojo.addOnLoad(function(){
dojo.hostenv._println_safe=true;
while(dojo.hostenv._println_buffer.length>0){
dojo.hostenv.println(dojo.hostenv._println_buffer.shift());
}
});
function dj_addNodeEvtHdlr(_c2,_c3,fp,_c5){
var _c6=_c2["on"+_c3]||function(){
};
_c2["on"+_c3]=function(){
fp.apply(_c2,arguments);
_c6.apply(_c2,arguments);
};
return true;
}
function dj_load_init(e){
var _c8=(e&&e.type)?e.type.toLowerCase():"load";
if(arguments.callee.initialized||(_c8!="domcontentloaded"&&_c8!="load")){
return;
}
arguments.callee.initialized=true;
if(typeof (_timer)!="undefined"){
clearInterval(_timer);
delete _timer;
}
var _c9=function(){
if(dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
};
if(dojo.hostenv.inFlightCount==0){
_c9();
dojo.hostenv.modulesLoaded();
}else{
dojo.addOnLoad(_c9);
}
}
if(document.addEventListener){
if(dojo.render.html.opera||(dojo.render.html.moz&&!djConfig.delayMozLoadingFix)){
document.addEventListener("DOMContentLoaded",dj_load_init,null);
}
window.addEventListener("load",dj_load_init,null);
}
if(dojo.render.html.ie&&dojo.render.os.win){
document.attachEvent("onreadystatechange",function(e){
if(document.readyState=="complete"){
dj_load_init();
}
});
}
if(/(WebKit|khtml)/i.test(navigator.userAgent)){
var _timer=setInterval(function(){
if(/loaded|complete/.test(document.readyState)){
dj_load_init();
}
},10);
}
if(dojo.render.html.ie){
dj_addNodeEvtHdlr(window,"beforeunload",function(){
dojo.hostenv._unloading=true;
window.setTimeout(function(){
dojo.hostenv._unloading=false;
},0);
});
}
dj_addNodeEvtHdlr(window,"unload",function(){
dojo.hostenv.unloaded();
if((!dojo.render.html.ie)||(dojo.render.html.ie&&dojo.hostenv._unloading)){
dojo.hostenv.unloaded();
}
});
dojo.hostenv.makeWidgets=function(){
var _cb=[];
if(djConfig.searchIds&&djConfig.searchIds.length>0){
_cb=_cb.concat(djConfig.searchIds);
}
if(dojo.hostenv.searchIds&&dojo.hostenv.searchIds.length>0){
_cb=_cb.concat(dojo.hostenv.searchIds);
}
if((djConfig.parseWidgets)||(_cb.length>0)){
if(dojo.evalObjPath("dojo.widget.Parse")){
var _cc=new dojo.xml.Parse();
if(_cb.length>0){
for(var x=0;x<_cb.length;x++){
var _ce=document.getElementById(_cb[x]);
if(!_ce){
continue;
}
var _cf=_cc.parseElement(_ce,null,true);
dojo.widget.getParser().createComponents(_cf);
}
}else{
if(djConfig.parseWidgets){
var _cf=_cc.parseElement(dojo.body(),null,true);
dojo.widget.getParser().createComponents(_cf);
}
}
}
}
};
dojo.addOnLoad(function(){
if(!dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
});
try{
if(dojo.render.html.ie){
document.namespaces.add("v","urn:schemas-microsoft-com:vml");
document.createStyleSheet().addRule("v\\:*","behavior:url(#default#VML)");
}
}
catch(e){
}
dojo.hostenv.writeIncludes=function(){
};
if(!dj_undef("document",this)){
dj_currentDocument=this.document;
}
dojo.doc=function(){
return dj_currentDocument;
};
dojo.body=function(){
return dojo.doc().body||dojo.doc().getElementsByTagName("body")[0];
};
dojo.byId=function(id,doc){
if((id)&&((typeof id=="string")||(id instanceof String))){
if(!doc){
doc=dj_currentDocument;
}
var ele=doc.getElementById(id);
if(ele&&(ele.id!=id)&&doc.all){
ele=null;
eles=doc.all[id];
if(eles){
if(eles.length){
for(var i=0;i<eles.length;i++){
if(eles[i].id==id){
ele=eles[i];
break;
}
}
}else{
ele=eles;
}
}
}
return ele;
}
return id;
};
dojo.setContext=function(_d4,_d5){
dj_currentContext=_d4;
dj_currentDocument=_d5;
};
dojo._fireCallback=function(_d6,_d7,_d8){
if((_d7)&&((typeof _d6=="string")||(_d6 instanceof String))){
_d6=_d7[_d6];
}
return (_d7?_d6.apply(_d7,_d8||[]):_d6());
};
dojo.withGlobal=function(_d9,_da,_db,_dc){
var _dd;
var _de=dj_currentContext;
var _df=dj_currentDocument;
try{
dojo.setContext(_d9,_d9.document);
_dd=dojo._fireCallback(_da,_db,_dc);
}
finally{
dojo.setContext(_de,_df);
}
return _dd;
};
dojo.withDoc=function(_e0,_e1,_e2,_e3){
var _e4;
var _e5=dj_currentDocument;
try{
dj_currentDocument=_e0;
_e4=dojo._fireCallback(_e1,_e2,_e3);
}
finally{
dj_currentDocument=_e5;
}
return _e4;
};
}
(function(){
if(typeof dj_usingBootstrap!="undefined"){
return;
}
var _e6=false;
var _e7=false;
var _e8=false;
if((typeof this["load"]=="function")&&((typeof this["Packages"]=="function")||(typeof this["Packages"]=="object"))){
_e6=true;
}else{
if(typeof this["load"]=="function"){
_e7=true;
}else{
if(window.widget){
_e8=true;
}
}
}
var _e9=[];
if((this["djConfig"])&&((djConfig["isDebug"])||(djConfig["debugAtAllCosts"]))){
_e9.push("debug.js");
}
if((this["djConfig"])&&(djConfig["debugAtAllCosts"])&&(!_e6)&&(!_e8)){
_e9.push("browser_debug.js");
}
var _ea=djConfig["baseScriptUri"];
if((this["djConfig"])&&(djConfig["baseLoaderUri"])){
_ea=djConfig["baseLoaderUri"];
}
for(var x=0;x<_e9.length;x++){
var _ec=_ea+"src/"+_e9[x];
if(_e6||_e7){
load(_ec);
}else{
try{
document.write("<scr"+"ipt type='text/javascript' src='"+_ec+"'></scr"+"ipt>");
}
catch(e){
var _ed=document.createElement("script");
_ed.src=_ec;
document.getElementsByTagName("head")[0].appendChild(_ed);
}
}
}
})();
dojo.provide("dojo.lang.common");
dojo.lang.inherits=function(_ee,_ef){
if(typeof _ef!="function"){
dojo.raise("dojo.inherits: superclass argument ["+_ef+"] must be a function (subclass: ["+_ee+"']");
}
_ee.prototype=new _ef();
_ee.prototype.constructor=_ee;
_ee.superclass=_ef.prototype;
_ee["super"]=_ef.prototype;
};
dojo.lang._mixin=function(obj,_f1){
var _f2={};
for(var x in _f1){
if((typeof _f2[x]=="undefined")||(_f2[x]!=_f1[x])){
obj[x]=_f1[x];
}
}
if(dojo.render.html.ie&&(typeof (_f1["toString"])=="function")&&(_f1["toString"]!=obj["toString"])&&(_f1["toString"]!=_f2["toString"])){
obj.toString=_f1.toString;
}
return obj;
};
dojo.lang.mixin=function(obj,_f5){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(obj,arguments[i]);
}
return obj;
};
dojo.lang.extend=function(_f8,_f9){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(_f8.prototype,arguments[i]);
}
return _f8;
};
dojo.inherits=dojo.lang.inherits;
dojo.mixin=dojo.lang.mixin;
dojo.extend=dojo.lang.extend;
dojo.lang.find=function(_fc,_fd,_fe,_ff){
if(!dojo.lang.isArrayLike(_fc)&&dojo.lang.isArrayLike(_fd)){
dojo.deprecated("dojo.lang.find(value, array)","use dojo.lang.find(array, value) instead","0.5");
var temp=_fc;
_fc=_fd;
_fd=temp;
}
var _101=dojo.lang.isString(_fc);
if(_101){
_fc=_fc.split("");
}
if(_ff){
var step=-1;
var i=_fc.length-1;
var end=-1;
}else{
var step=1;
var i=0;
var end=_fc.length;
}
if(_fe){
while(i!=end){
if(_fc[i]===_fd){
return i;
}
i+=step;
}
}else{
while(i!=end){
if(_fc[i]==_fd){
return i;
}
i+=step;
}
}
return -1;
};
dojo.lang.indexOf=dojo.lang.find;
dojo.lang.findLast=function(_105,_106,_107){
return dojo.lang.find(_105,_106,_107,true);
};
dojo.lang.lastIndexOf=dojo.lang.findLast;
dojo.lang.inArray=function(_108,_109){
return dojo.lang.find(_108,_109)>-1;
};
dojo.lang.isObject=function(it){
if(typeof it=="undefined"){
return false;
}
return (typeof it=="object"||it===null||dojo.lang.isArray(it)||dojo.lang.isFunction(it));
};
dojo.lang.isArray=function(it){
return (it&&it instanceof Array||typeof it=="array");
};
dojo.lang.isArrayLike=function(it){
if((!it)||(dojo.lang.isUndefined(it))){
return false;
}
if(dojo.lang.isString(it)){
return false;
}
if(dojo.lang.isFunction(it)){
return false;
}
if(dojo.lang.isArray(it)){
return true;
}
if((it.tagName)&&(it.tagName.toLowerCase()=="form")){
return false;
}
if(dojo.lang.isNumber(it.length)&&isFinite(it.length)){
return true;
}
return false;
};
dojo.lang.isFunction=function(it){
if(!it){
return false;
}
if((typeof (it)=="function")&&(it=="[object NodeList]")){
return false;
}
return (it instanceof Function||typeof it=="function");
};
dojo.lang.isString=function(it){
return (typeof it=="string"||it instanceof String);
};
dojo.lang.isAlien=function(it){
if(!it){
return false;
}
return !dojo.lang.isFunction()&&/\{\s*\[native code\]\s*\}/.test(String(it));
};
dojo.lang.isBoolean=function(it){
return (it instanceof Boolean||typeof it=="boolean");
};
dojo.lang.isNumber=function(it){
return (it instanceof Number||typeof it=="number");
};
dojo.lang.isUndefined=function(it){
return ((typeof (it)=="undefined")&&(it==undefined));
};
dojo.provide("dojo.lang.array");
dojo.lang.has=function(obj,name){
try{
return typeof obj[name]!="undefined";
}
catch(e){
return false;
}
};
dojo.lang.isEmpty=function(obj){
if(dojo.lang.isObject(obj)){
var tmp={};
var _117=0;
for(var x in obj){
if(obj[x]&&(!tmp[x])){
_117++;
break;
}
}
return _117==0;
}else{
if(dojo.lang.isArrayLike(obj)||dojo.lang.isString(obj)){
return obj.length==0;
}
}
};
dojo.lang.map=function(arr,obj,_11b){
var _11c=dojo.lang.isString(arr);
if(_11c){
arr=arr.split("");
}
if(dojo.lang.isFunction(obj)&&(!_11b)){
_11b=obj;
obj=dj_global;
}else{
if(dojo.lang.isFunction(obj)&&_11b){
var _11d=obj;
obj=_11b;
_11b=_11d;
}
}
if(Array.map){
var _11e=Array.map(arr,_11b,obj);
}else{
var _11e=[];
for(var i=0;i<arr.length;++i){
_11e.push(_11b.call(obj,arr[i]));
}
}
if(_11c){
return _11e.join("");
}else{
return _11e;
}
};
dojo.lang.reduce=function(arr,_121,obj,_123){
var _124=_121;
var ob=obj?obj:dj_global;
dojo.lang.map(arr,function(val){
_124=_123.call(ob,_124,val);
});
return _124;
};
dojo.lang.forEach=function(_127,_128,_129){
if(dojo.lang.isString(_127)){
_127=_127.split("");
}
if(Array.forEach){
Array.forEach(_127,_128,_129);
}else{
if(!_129){
_129=dj_global;
}
for(var i=0,l=_127.length;i<l;i++){
_128.call(_129,_127[i],i,_127);
}
}
};
dojo.lang._everyOrSome=function(_12c,arr,_12e,_12f){
if(dojo.lang.isString(arr)){
arr=arr.split("");
}
if(Array.every){
return Array[_12c?"every":"some"](arr,_12e,_12f);
}else{
if(!_12f){
_12f=dj_global;
}
for(var i=0,l=arr.length;i<l;i++){
var _132=_12e.call(_12f,arr[i],i,arr);
if(_12c&&!_132){
return false;
}else{
if((!_12c)&&(_132)){
return true;
}
}
}
return Boolean(_12c);
}
};
dojo.lang.every=function(arr,_134,_135){
return this._everyOrSome(true,arr,_134,_135);
};
dojo.lang.some=function(arr,_137,_138){
return this._everyOrSome(false,arr,_137,_138);
};
dojo.lang.filter=function(arr,_13a,_13b){
var _13c=dojo.lang.isString(arr);
if(_13c){
arr=arr.split("");
}
var _13d;
if(Array.filter){
_13d=Array.filter(arr,_13a,_13b);
}else{
if(!_13b){
if(arguments.length>=3){
dojo.raise("thisObject doesn't exist!");
}
_13b=dj_global;
}
_13d=[];
for(var i=0;i<arr.length;i++){
if(_13a.call(_13b,arr[i],i,arr)){
_13d.push(arr[i]);
}
}
}
if(_13c){
return _13d.join("");
}else{
return _13d;
}
};
dojo.lang.unnest=function(){
var out=[];
for(var i=0;i<arguments.length;i++){
if(dojo.lang.isArrayLike(arguments[i])){
var add=dojo.lang.unnest.apply(this,arguments[i]);
out=out.concat(add);
}else{
out.push(arguments[i]);
}
}
return out;
};
dojo.lang.toArray=function(_142,_143){
var _144=[];
for(var i=_143||0;i<_142.length;i++){
_144.push(_142[i]);
}
return _144;
};
dojo.provide("dojo.lang.extras");
dojo.lang.setTimeout=function(func,_147){
var _148=window,_149=2;
if(!dojo.lang.isFunction(func)){
_148=func;
func=_147;
_147=arguments[2];
_149++;
}
if(dojo.lang.isString(func)){
func=_148[func];
}
var args=[];
for(var i=_149;i<arguments.length;i++){
args.push(arguments[i]);
}
return dojo.global().setTimeout(function(){
func.apply(_148,args);
},_147);
};
dojo.lang.clearTimeout=function(_14c){
dojo.global().clearTimeout(_14c);
};
dojo.lang.getNameInObj=function(ns,item){
if(!ns){
ns=dj_global;
}
for(var x in ns){
if(ns[x]===item){
return new String(x);
}
}
return null;
};
dojo.lang.shallowCopy=function(obj,deep){
var i,ret;
if(obj===null){
return null;
}
if(dojo.lang.isObject(obj)){
ret=new obj.constructor();
for(i in obj){
if(dojo.lang.isUndefined(ret[i])){
ret[i]=deep?dojo.lang.shallowCopy(obj[i],deep):obj[i];
}
}
}else{
if(dojo.lang.isArray(obj)){
ret=[];
for(i=0;i<obj.length;i++){
ret[i]=deep?dojo.lang.shallowCopy(obj[i],deep):obj[i];
}
}else{
ret=obj;
}
}
return ret;
};
dojo.lang.firstValued=function(){
for(var i=0;i<arguments.length;i++){
if(typeof arguments[i]!="undefined"){
return arguments[i];
}
}
return undefined;
};
dojo.lang.getObjPathValue=function(_155,_156,_157){
with(dojo.parseObjPath(_155,_156,_157)){
return dojo.evalProp(prop,obj,_157);
}
};
dojo.lang.setObjPathValue=function(_158,_159,_15a,_15b){
if(arguments.length<4){
_15b=true;
}
with(dojo.parseObjPath(_158,_15a,_15b)){
if(obj&&(_15b||(prop in obj))){
obj[prop]=_159;
}
}
};
dojo.provide("dojo.lang.declare");
dojo.lang.declare=function(_15c,_15d,init,_15f){
if((dojo.lang.isFunction(_15f))||((!_15f)&&(!dojo.lang.isFunction(init)))){
var temp=_15f;
_15f=init;
init=temp;
}
var _161=[];
if(dojo.lang.isArray(_15d)){
_161=_15d;
_15d=_161.shift();
}
if(!init){
init=dojo.evalObjPath(_15c,false);
if((init)&&(!dojo.lang.isFunction(init))){
init=null;
}
}
var ctor=dojo.lang.declare._makeConstructor();
var scp=(_15d?_15d.prototype:null);
if(scp){
scp.prototyping=true;
ctor.prototype=new _15d();
scp.prototyping=false;
}
ctor.superclass=scp;
ctor.mixins=_161;
for(var i=0,l=_161.length;i<l;i++){
dojo.lang.extend(ctor,_161[i].prototype);
}
ctor.prototype.initializer=null;
ctor.prototype.declaredClass=_15c;
if(dojo.lang.isArray(_15f)){
dojo.lang.extend.apply(dojo.lang,[ctor].concat(_15f));
}else{
dojo.lang.extend(ctor,(_15f)||{});
}
dojo.lang.extend(ctor,dojo.lang.declare._common);
ctor.prototype.constructor=ctor;
ctor.prototype.initializer=(ctor.prototype.initializer)||(init)||(function(){
});
dojo.lang.setObjPathValue(_15c,ctor,null,true);
return ctor;
};
dojo.lang.declare._makeConstructor=function(){
return function(){
var self=this._getPropContext();
var s=self.constructor.superclass;
if((s)&&(s.constructor)){
if(s.constructor==arguments.callee){
this._inherited("constructor",arguments);
}else{
this._contextMethod(s,"constructor",arguments);
}
}
var ms=(self.constructor.mixins)||([]);
for(var i=0,m;(m=ms[i]);i++){
(((m.prototype)&&(m.prototype.initializer))||(m)).apply(this,arguments);
}
if((!this.prototyping)&&(self.initializer)){
self.initializer.apply(this,arguments);
}
};
};
dojo.lang.declare._common={_getPropContext:function(){
return (this.___proto||this);
},_contextMethod:function(_16b,_16c,args){
var _16e,_16f=this.___proto;
this.___proto=_16b;
try{
_16e=_16b[_16c].apply(this,(args||[]));
}
catch(e){
throw e;
}
finally{
this.___proto=_16f;
}
return _16e;
},_inherited:function(prop,args){
var p=this._getPropContext();
do{
if((!p.constructor)||(!p.constructor.superclass)){
return;
}
p=p.constructor.superclass;
}while(!(prop in p));
return (dojo.lang.isFunction(p[prop])?this._contextMethod(p,prop,args):p[prop]);
}};
dojo.declare=dojo.lang.declare;
dojo.provide("dojo.lang.func");
dojo.lang.hitch=function(_173,_174){
var fcn=(dojo.lang.isString(_174)?_173[_174]:_174)||function(){
};
return function(){
return fcn.apply(_173,arguments);
};
};
dojo.lang.anonCtr=0;
dojo.lang.anon={};
dojo.lang.nameAnonFunc=function(_176,_177,_178){
var nso=(_177||dojo.lang.anon);
if((_178)||((dj_global["djConfig"])&&(djConfig["slowAnonFuncLookups"]==true))){
for(var x in nso){
try{
if(nso[x]===_176){
return x;
}
}
catch(e){
}
}
}
var ret="__"+dojo.lang.anonCtr++;
while(typeof nso[ret]!="undefined"){
ret="__"+dojo.lang.anonCtr++;
}
nso[ret]=_176;
return ret;
};
dojo.lang.forward=function(_17c){
return function(){
return this[_17c].apply(this,arguments);
};
};
dojo.lang.curry=function(ns,func){
var _17f=[];
ns=ns||dj_global;
if(dojo.lang.isString(func)){
func=ns[func];
}
for(var x=2;x<arguments.length;x++){
_17f.push(arguments[x]);
}
var _181=(func["__preJoinArity"]||func.length)-_17f.length;
function gather(_182,_183,_184){
var _185=_184;
var _186=_183.slice(0);
for(var x=0;x<_182.length;x++){
_186.push(_182[x]);
}
_184=_184-_182.length;
if(_184<=0){
var res=func.apply(ns,_186);
_184=_185;
return res;
}else{
return function(){
return gather(arguments,_186,_184);
};
}
}
return gather([],_17f,_181);
};
dojo.lang.curryArguments=function(ns,func,args,_18c){
var _18d=[];
var x=_18c||0;
for(x=_18c;x<args.length;x++){
_18d.push(args[x]);
}
return dojo.lang.curry.apply(dojo.lang,[ns,func].concat(_18d));
};
dojo.lang.tryThese=function(){
for(var x=0;x<arguments.length;x++){
try{
if(typeof arguments[x]=="function"){
var ret=(arguments[x]());
if(ret){
return ret;
}
}
}
catch(e){
dojo.debug(e);
}
}
};
dojo.lang.delayThese=function(farr,cb,_193,_194){
if(!farr.length){
if(typeof _194=="function"){
_194();
}
return;
}
if((typeof _193=="undefined")&&(typeof cb=="number")){
_193=cb;
cb=function(){
};
}else{
if(!cb){
cb=function(){
};
if(!_193){
_193=0;
}
}
}
setTimeout(function(){
(farr.shift())();
cb();
dojo.lang.delayThese(farr,cb,_193,_194);
},_193);
};
dojo.provide("dojo.event.common");
dojo.event=new function(){
this._canTimeout=dojo.lang.isFunction(dj_global["setTimeout"])||dojo.lang.isAlien(dj_global["setTimeout"]);
function interpolateArgs(args,_196){
var dl=dojo.lang;
var ao={srcObj:dj_global,srcFunc:null,adviceObj:dj_global,adviceFunc:null,aroundObj:null,aroundFunc:null,adviceType:(args.length>2)?args[0]:"after",precedence:"last",once:false,delay:null,rate:0,adviceMsg:false};
switch(args.length){
case 0:
return;
case 1:
return;
case 2:
ao.srcFunc=args[0];
ao.adviceFunc=args[1];
break;
case 3:
if((dl.isObject(args[0]))&&(dl.isString(args[1]))&&(dl.isString(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
}else{
if((dl.isString(args[1]))&&(dl.isString(args[2]))){
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
}else{
if((dl.isObject(args[0]))&&(dl.isString(args[1]))&&(dl.isFunction(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
var _199=dl.nameAnonFunc(args[2],ao.adviceObj,_196);
ao.adviceFunc=_199;
}else{
if((dl.isFunction(args[0]))&&(dl.isObject(args[1]))&&(dl.isString(args[2]))){
ao.adviceType="after";
ao.srcObj=dj_global;
var _199=dl.nameAnonFunc(args[0],ao.srcObj,_196);
ao.srcFunc=_199;
ao.adviceObj=args[1];
ao.adviceFunc=args[2];
}
}
}
}
break;
case 4:
if((dl.isObject(args[0]))&&(dl.isObject(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isString(args[1]))&&(dl.isObject(args[2]))){
ao.adviceType=args[0];
ao.srcObj=dj_global;
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isFunction(args[1]))&&(dl.isObject(args[2]))){
ao.adviceType=args[0];
ao.srcObj=dj_global;
var _199=dl.nameAnonFunc(args[1],dj_global,_196);
ao.srcFunc=_199;
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isObject(args[1]))&&(dl.isString(args[2]))&&(dl.isFunction(args[3]))){
ao.srcObj=args[1];
ao.srcFunc=args[2];
var _199=dl.nameAnonFunc(args[3],dj_global,_196);
ao.adviceObj=dj_global;
ao.adviceFunc=_199;
}else{
if(dl.isObject(args[1])){
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=dj_global;
ao.adviceFunc=args[3];
}else{
if(dl.isObject(args[2])){
ao.srcObj=dj_global;
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
ao.srcObj=ao.adviceObj=ao.aroundObj=dj_global;
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
ao.aroundFunc=args[3];
}
}
}
}
}
}
break;
case 6:
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=args[3];
ao.adviceFunc=args[4];
ao.aroundFunc=args[5];
ao.aroundObj=dj_global;
break;
default:
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=args[3];
ao.adviceFunc=args[4];
ao.aroundObj=args[5];
ao.aroundFunc=args[6];
ao.once=args[7];
ao.delay=args[8];
ao.rate=args[9];
ao.adviceMsg=args[10];
break;
}
if(dl.isFunction(ao.aroundFunc)){
var _199=dl.nameAnonFunc(ao.aroundFunc,ao.aroundObj,_196);
ao.aroundFunc=_199;
}
if(dl.isFunction(ao.srcFunc)){
ao.srcFunc=dl.getNameInObj(ao.srcObj,ao.srcFunc);
}
if(dl.isFunction(ao.adviceFunc)){
ao.adviceFunc=dl.getNameInObj(ao.adviceObj,ao.adviceFunc);
}
if((ao.aroundObj)&&(dl.isFunction(ao.aroundFunc))){
ao.aroundFunc=dl.getNameInObj(ao.aroundObj,ao.aroundFunc);
}
if(!ao.srcObj){
dojo.raise("bad srcObj for srcFunc: "+ao.srcFunc);
}
if(!ao.adviceObj){
dojo.raise("bad adviceObj for adviceFunc: "+ao.adviceFunc);
}
if(!ao.adviceFunc){
dojo.debug("bad adviceFunc for srcFunc: "+ao.srcFunc);
dojo.debugShallow(ao);
}
return ao;
}
this.connect=function(){
if(arguments.length==1){
var ao=arguments[0];
}else{
var ao=interpolateArgs(arguments,true);
}
if(dojo.lang.isString(ao.srcFunc)&&(ao.srcFunc.toLowerCase()=="onkey")){
if(dojo.render.html.ie){
ao.srcFunc="onkeydown";
this.connect(ao);
}
ao.srcFunc="onkeypress";
}
if(dojo.lang.isArray(ao.srcObj)&&ao.srcObj!=""){
var _19b={};
for(var x in ao){
_19b[x]=ao[x];
}
var mjps=[];
dojo.lang.forEach(ao.srcObj,function(src){
if((dojo.render.html.capable)&&(dojo.lang.isString(src))){
src=dojo.byId(src);
}
_19b.srcObj=src;
mjps.push(dojo.event.connect.call(dojo.event,_19b));
});
return mjps;
}
var mjp=dojo.event.MethodJoinPoint.getForMethod(ao.srcObj,ao.srcFunc);
if(ao.adviceFunc){
var mjp2=dojo.event.MethodJoinPoint.getForMethod(ao.adviceObj,ao.adviceFunc);
}
mjp.kwAddAdvice(ao);
return mjp;
};
this.log=function(a1,a2){
var _1a3;
if((arguments.length==1)&&(typeof a1=="object")){
_1a3=a1;
}else{
_1a3={srcObj:a1,srcFunc:a2};
}
_1a3.adviceFunc=function(){
var _1a4=[];
for(var x=0;x<arguments.length;x++){
_1a4.push(arguments[x]);
}
dojo.debug("("+_1a3.srcObj+")."+_1a3.srcFunc,":",_1a4.join(", "));
};
this.kwConnect(_1a3);
};
this.connectBefore=function(){
var args=["before"];
for(var i=0;i<arguments.length;i++){
args.push(arguments[i]);
}
return this.connect.apply(this,args);
};
this.connectAround=function(){
var args=["around"];
for(var i=0;i<arguments.length;i++){
args.push(arguments[i]);
}
return this.connect.apply(this,args);
};
this.connectOnce=function(){
var ao=interpolateArgs(arguments,true);
ao.once=true;
return this.connect(ao);
};
this._kwConnectImpl=function(_1ab,_1ac){
var fn=(_1ac)?"disconnect":"connect";
if(typeof _1ab["srcFunc"]=="function"){
_1ab.srcObj=_1ab["srcObj"]||dj_global;
var _1ae=dojo.lang.nameAnonFunc(_1ab.srcFunc,_1ab.srcObj,true);
_1ab.srcFunc=_1ae;
}
if(typeof _1ab["adviceFunc"]=="function"){
_1ab.adviceObj=_1ab["adviceObj"]||dj_global;
var _1ae=dojo.lang.nameAnonFunc(_1ab.adviceFunc,_1ab.adviceObj,true);
_1ab.adviceFunc=_1ae;
}
_1ab.srcObj=_1ab["srcObj"]||dj_global;
_1ab.adviceObj=_1ab["adviceObj"]||_1ab["targetObj"]||dj_global;
_1ab.adviceFunc=_1ab["adviceFunc"]||_1ab["targetFunc"];
return dojo.event[fn](_1ab);
};
this.kwConnect=function(_1af){
return this._kwConnectImpl(_1af,false);
};
this.disconnect=function(){
if(arguments.length==1){
var ao=arguments[0];
}else{
var ao=interpolateArgs(arguments,true);
}
if(!ao.adviceFunc){
return;
}
if(dojo.lang.isString(ao.srcFunc)&&(ao.srcFunc.toLowerCase()=="onkey")){
if(dojo.render.html.ie){
ao.srcFunc="onkeydown";
this.disconnect(ao);
}
ao.srcFunc="onkeypress";
}
var mjp=dojo.event.MethodJoinPoint.getForMethod(ao.srcObj,ao.srcFunc);
return mjp.removeAdvice(ao.adviceObj,ao.adviceFunc,ao.adviceType,ao.once);
};
this.kwDisconnect=function(_1b2){
return this._kwConnectImpl(_1b2,true);
};
};
dojo.event.MethodInvocation=function(_1b3,obj,args){
this.jp_=_1b3;
this.object=obj;
this.args=[];
for(var x=0;x<args.length;x++){
this.args[x]=args[x];
}
this.around_index=-1;
};
dojo.event.MethodInvocation.prototype.proceed=function(){
this.around_index++;
if(this.around_index>=this.jp_.around.length){
return this.jp_.object[this.jp_.methodname].apply(this.jp_.object,this.args);
}else{
var ti=this.jp_.around[this.around_index];
var mobj=ti[0]||dj_global;
var meth=ti[1];
return mobj[meth].call(mobj,this);
}
};
dojo.event.MethodJoinPoint=function(obj,_1bb){
this.object=obj||dj_global;
this.methodname=_1bb;
this.methodfunc=this.object[_1bb];
this.squelch=false;
};
dojo.event.MethodJoinPoint.getForMethod=function(obj,_1bd){
if(!obj){
obj=dj_global;
}
if(!obj[_1bd]){
obj[_1bd]=function(){
};
if(!obj[_1bd]){
dojo.raise("Cannot set do-nothing method on that object "+_1bd);
}
}else{
if((!dojo.lang.isFunction(obj[_1bd]))&&(!dojo.lang.isAlien(obj[_1bd]))){
return null;
}
}
var _1be=_1bd+"$joinpoint";
var _1bf=_1bd+"$joinpoint$method";
var _1c0=obj[_1be];
if(!_1c0){
var _1c1=false;
if(dojo.event["browser"]){
if((obj["attachEvent"])||(obj["nodeType"])||(obj["addEventListener"])){
_1c1=true;
dojo.event.browser.addClobberNodeAttrs(obj,[_1be,_1bf,_1bd]);
}
}
var _1c2=obj[_1bd].length;
obj[_1bf]=obj[_1bd];
_1c0=obj[_1be]=new dojo.event.MethodJoinPoint(obj,_1bf);
obj[_1bd]=function(){
var args=[];
if((_1c1)&&(!arguments.length)){
var evt=null;
try{
if(obj.ownerDocument){
evt=obj.ownerDocument.parentWindow.event;
}else{
if(obj.documentElement){
evt=obj.documentElement.ownerDocument.parentWindow.event;
}else{
if(obj.event){
evt=obj.event;
}else{
evt=window.event;
}
}
}
}
catch(e){
evt=window.event;
}
if(evt){
args.push(dojo.event.browser.fixEvent(evt,this));
}
}else{
for(var x=0;x<arguments.length;x++){
if((x==0)&&(_1c1)&&(dojo.event.browser.isEvent(arguments[x]))){
args.push(dojo.event.browser.fixEvent(arguments[x],this));
}else{
args.push(arguments[x]);
}
}
}
return _1c0.run.apply(_1c0,args);
};
obj[_1bd].__preJoinArity=_1c2;
}
return _1c0;
};
dojo.lang.extend(dojo.event.MethodJoinPoint,{unintercept:function(){
this.object[this.methodname]=this.methodfunc;
this.before=[];
this.after=[];
this.around=[];
},disconnect:dojo.lang.forward("unintercept"),run:function(){
var obj=this.object||dj_global;
var args=arguments;
var _1c8=[];
for(var x=0;x<args.length;x++){
_1c8[x]=args[x];
}
var _1ca=function(marr){
if(!marr){
dojo.debug("Null argument to unrollAdvice()");
return;
}
var _1cc=marr[0]||dj_global;
var _1cd=marr[1];
if(!_1cc[_1cd]){
dojo.raise("function \""+_1cd+"\" does not exist on \""+_1cc+"\"");
}
var _1ce=marr[2]||dj_global;
var _1cf=marr[3];
var msg=marr[6];
var _1d1;
var to={args:[],jp_:this,object:obj,proceed:function(){
return _1cc[_1cd].apply(_1cc,to.args);
}};
to.args=_1c8;
var _1d3=parseInt(marr[4]);
var _1d4=((!isNaN(_1d3))&&(marr[4]!==null)&&(typeof marr[4]!="undefined"));
if(marr[5]){
var rate=parseInt(marr[5]);
var cur=new Date();
var _1d7=false;
if((marr["last"])&&((cur-marr.last)<=rate)){
if(dojo.event._canTimeout){
if(marr["delayTimer"]){
clearTimeout(marr.delayTimer);
}
var tod=parseInt(rate*2);
var mcpy=dojo.lang.shallowCopy(marr);
marr.delayTimer=setTimeout(function(){
mcpy[5]=0;
_1ca(mcpy);
},tod);
}
return;
}else{
marr.last=cur;
}
}
if(_1cf){
_1ce[_1cf].call(_1ce,to);
}else{
if((_1d4)&&((dojo.render.html)||(dojo.render.svg))){
dj_global["setTimeout"](function(){
if(msg){
_1cc[_1cd].call(_1cc,to);
}else{
_1cc[_1cd].apply(_1cc,args);
}
},_1d3);
}else{
if(msg){
_1cc[_1cd].call(_1cc,to);
}else{
_1cc[_1cd].apply(_1cc,args);
}
}
}
};
var _1da=function(){
if(this.squelch){
try{
return _1ca.apply(this,arguments);
}
catch(e){
dojo.debug(e);
}
}else{
return _1ca.apply(this,arguments);
}
};
if((this["before"])&&(this.before.length>0)){
dojo.lang.forEach(this.before.concat(new Array()),_1da);
}
var _1db;
try{
if((this["around"])&&(this.around.length>0)){
var mi=new dojo.event.MethodInvocation(this,obj,args);
_1db=mi.proceed();
}else{
if(this.methodfunc){
_1db=this.object[this.methodname].apply(this.object,args);
}
}
}
catch(e){
if(!this.squelch){
dojo.raise(e);
}
}
if((this["after"])&&(this.after.length>0)){
dojo.lang.forEach(this.after.concat(new Array()),_1da);
}
return (this.methodfunc)?_1db:null;
},getArr:function(kind){
var type="after";
if((typeof kind=="string")&&(kind.indexOf("before")!=-1)){
type="before";
}else{
if(kind=="around"){
type="around";
}
}
if(!this[type]){
this[type]=[];
}
return this[type];
},kwAddAdvice:function(args){
this.addAdvice(args["adviceObj"],args["adviceFunc"],args["aroundObj"],args["aroundFunc"],args["adviceType"],args["precedence"],args["once"],args["delay"],args["rate"],args["adviceMsg"]);
},addAdvice:function(_1e0,_1e1,_1e2,_1e3,_1e4,_1e5,once,_1e7,rate,_1e9){
var arr=this.getArr(_1e4);
if(!arr){
dojo.raise("bad this: "+this);
}
var ao=[_1e0,_1e1,_1e2,_1e3,_1e7,rate,_1e9];
if(once){
if(this.hasAdvice(_1e0,_1e1,_1e4,arr)>=0){
return;
}
}
if(_1e5=="first"){
arr.unshift(ao);
}else{
arr.push(ao);
}
},hasAdvice:function(_1ec,_1ed,_1ee,arr){
if(!arr){
arr=this.getArr(_1ee);
}
var ind=-1;
for(var x=0;x<arr.length;x++){
var aao=(typeof _1ed=="object")?(new String(_1ed)).toString():_1ed;
var a1o=(typeof arr[x][1]=="object")?(new String(arr[x][1])).toString():arr[x][1];
if((arr[x][0]==_1ec)&&(a1o==aao)){
ind=x;
}
}
return ind;
},removeAdvice:function(_1f4,_1f5,_1f6,once){
var arr=this.getArr(_1f6);
var ind=this.hasAdvice(_1f4,_1f5,_1f6,arr);
if(ind==-1){
return false;
}
while(ind!=-1){
arr.splice(ind,1);
if(once){
break;
}
ind=this.hasAdvice(_1f4,_1f5,_1f6,arr);
}
return true;
}});
dojo.provide("dojo.event.topic");
dojo.event.topic=new function(){
this.topics={};
this.getTopic=function(_1fa){
if(!this.topics[_1fa]){
this.topics[_1fa]=new this.TopicImpl(_1fa);
}
return this.topics[_1fa];
};
this.registerPublisher=function(_1fb,obj,_1fd){
var _1fb=this.getTopic(_1fb);
_1fb.registerPublisher(obj,_1fd);
};
this.subscribe=function(_1fe,obj,_200){
var _1fe=this.getTopic(_1fe);
_1fe.subscribe(obj,_200);
};
this.unsubscribe=function(_201,obj,_203){
var _201=this.getTopic(_201);
_201.unsubscribe(obj,_203);
};
this.destroy=function(_204){
this.getTopic(_204).destroy();
delete this.topics[_204];
};
this.publishApply=function(_205,args){
var _205=this.getTopic(_205);
_205.sendMessage.apply(_205,args);
};
this.publish=function(_207,_208){
var _207=this.getTopic(_207);
var args=[];
for(var x=1;x<arguments.length;x++){
args.push(arguments[x]);
}
_207.sendMessage.apply(_207,args);
};
};
dojo.event.topic.TopicImpl=function(_20b){
this.topicName=_20b;
this.subscribe=function(_20c,_20d){
var tf=_20d||_20c;
var to=(!_20d)?dj_global:_20c;
return dojo.event.kwConnect({srcObj:this,srcFunc:"sendMessage",adviceObj:to,adviceFunc:tf});
};
this.unsubscribe=function(_210,_211){
var tf=(!_211)?_210:_211;
var to=(!_211)?null:_210;
return dojo.event.kwDisconnect({srcObj:this,srcFunc:"sendMessage",adviceObj:to,adviceFunc:tf});
};
this._getJoinPoint=function(){
return dojo.event.MethodJoinPoint.getForMethod(this,"sendMessage");
};
this.setSquelch=function(_214){
this._getJoinPoint().squelch=_214;
};
this.destroy=function(){
this._getJoinPoint().disconnect();
};
this.registerPublisher=function(_215,_216){
dojo.event.connect(_215,_216,this,"sendMessage");
};
this.sendMessage=function(_217){
};
};
dojo.provide("dojo.event.browser");
dojo._ie_clobber=new function(){
this.clobberNodes=[];
function nukeProp(node,prop){
try{
node[prop]=null;
}
catch(e){
}
try{
delete node[prop];
}
catch(e){
}
try{
node.removeAttribute(prop);
}
catch(e){
}
}
this.clobber=function(_21a){
var na;
var tna;
if(_21a){
tna=_21a.all||_21a.getElementsByTagName("*");
na=[_21a];
for(var x=0;x<tna.length;x++){
if(tna[x]["__doClobber__"]){
na.push(tna[x]);
}
}
}else{
try{
window.onload=null;
}
catch(e){
}
na=(this.clobberNodes.length)?this.clobberNodes:document.all;
}
tna=null;
var _21e={};
for(var i=na.length-1;i>=0;i=i-1){
var el=na[i];
try{
if(el&&el["__clobberAttrs__"]){
for(var j=0;j<el.__clobberAttrs__.length;j++){
nukeProp(el,el.__clobberAttrs__[j]);
}
nukeProp(el,"__clobberAttrs__");
nukeProp(el,"__doClobber__");
}
}
catch(e){
}
}
na=null;
};
};
if(dojo.render.html.ie){
dojo.addOnUnload(function(){
dojo._ie_clobber.clobber();
try{
if((dojo["widget"])&&(dojo.widget["manager"])){
dojo.widget.manager.destroyAll();
}
}
catch(e){
}
try{
window.onload=null;
}
catch(e){
}
try{
window.onunload=null;
}
catch(e){
}
dojo._ie_clobber.clobberNodes=[];
});
}
dojo.event.browser=new function(){
var _222=0;
this.normalizedEventName=function(_223){
switch(_223){
case "CheckboxStateChange":
case "DOMAttrModified":
case "DOMMenuItemActive":
case "DOMMenuItemInactive":
case "DOMMouseScroll":
case "DOMNodeInserted":
case "DOMNodeRemoved":
case "RadioStateChange":
return _223;
break;
default:
return _223.toLowerCase();
break;
}
};
this.clean=function(node){
if(dojo.render.html.ie){
dojo._ie_clobber.clobber(node);
}
};
this.addClobberNode=function(node){
if(!dojo.render.html.ie){
return;
}
if(!node["__doClobber__"]){
node.__doClobber__=true;
dojo._ie_clobber.clobberNodes.push(node);
node.__clobberAttrs__=[];
}
};
this.addClobberNodeAttrs=function(node,_227){
if(!dojo.render.html.ie){
return;
}
this.addClobberNode(node);
for(var x=0;x<_227.length;x++){
node.__clobberAttrs__.push(_227[x]);
}
};
this.removeListener=function(node,_22a,fp,_22c){
if(!_22c){
var _22c=false;
}
_22a=dojo.event.browser.normalizedEventName(_22a);
if((_22a=="onkey")||(_22a=="key")){
if(dojo.render.html.ie){
this.removeListener(node,"onkeydown",fp,_22c);
}
_22a="onkeypress";
}
if(_22a.substr(0,2)=="on"){
_22a=_22a.substr(2);
}
if(node.removeEventListener){
node.removeEventListener(_22a,fp,_22c);
}
};
this.addListener=function(node,_22e,fp,_230,_231){
if(!node){
return;
}
if(!_230){
var _230=false;
}
_22e=dojo.event.browser.normalizedEventName(_22e);
if((_22e=="onkey")||(_22e=="key")){
if(dojo.render.html.ie){
this.addListener(node,"onkeydown",fp,_230,_231);
}
_22e="onkeypress";
}
if(_22e.substr(0,2)!="on"){
_22e="on"+_22e;
}
if(!_231){
var _232=function(evt){
if(!evt){
evt=window.event;
}
var ret=fp(dojo.event.browser.fixEvent(evt,this));
if(_230){
dojo.event.browser.stopEvent(evt);
}
return ret;
};
}else{
_232=fp;
}
if(node.addEventListener){
node.addEventListener(_22e.substr(2),_232,_230);
return _232;
}else{
if(typeof node[_22e]=="function"){
var _235=node[_22e];
node[_22e]=function(e){
_235(e);
return _232(e);
};
}else{
node[_22e]=_232;
}
if(dojo.render.html.ie){
this.addClobberNodeAttrs(node,[_22e]);
}
return _232;
}
};
this.isEvent=function(obj){
return (typeof obj!="undefined")&&(typeof Event!="undefined")&&(obj.eventPhase);
};
this.currentEvent=null;
this.callListener=function(_238,_239){
if(typeof _238!="function"){
dojo.raise("listener not a function: "+_238);
}
dojo.event.browser.currentEvent.currentTarget=_239;
return _238.call(_239,dojo.event.browser.currentEvent);
};
this._stopPropagation=function(){
dojo.event.browser.currentEvent.cancelBubble=true;
};
this._preventDefault=function(){
dojo.event.browser.currentEvent.returnValue=false;
};
this.keys={KEY_BACKSPACE:8,KEY_TAB:9,KEY_CLEAR:12,KEY_ENTER:13,KEY_SHIFT:16,KEY_CTRL:17,KEY_ALT:18,KEY_PAUSE:19,KEY_CAPS_LOCK:20,KEY_ESCAPE:27,KEY_SPACE:32,KEY_PAGE_UP:33,KEY_PAGE_DOWN:34,KEY_END:35,KEY_HOME:36,KEY_LEFT_ARROW:37,KEY_UP_ARROW:38,KEY_RIGHT_ARROW:39,KEY_DOWN_ARROW:40,KEY_INSERT:45,KEY_DELETE:46,KEY_HELP:47,KEY_LEFT_WINDOW:91,KEY_RIGHT_WINDOW:92,KEY_SELECT:93,KEY_NUMPAD_0:96,KEY_NUMPAD_1:97,KEY_NUMPAD_2:98,KEY_NUMPAD_3:99,KEY_NUMPAD_4:100,KEY_NUMPAD_5:101,KEY_NUMPAD_6:102,KEY_NUMPAD_7:103,KEY_NUMPAD_8:104,KEY_NUMPAD_9:105,KEY_NUMPAD_MULTIPLY:106,KEY_NUMPAD_PLUS:107,KEY_NUMPAD_ENTER:108,KEY_NUMPAD_MINUS:109,KEY_NUMPAD_PERIOD:110,KEY_NUMPAD_DIVIDE:111,KEY_F1:112,KEY_F2:113,KEY_F3:114,KEY_F4:115,KEY_F5:116,KEY_F6:117,KEY_F7:118,KEY_F8:119,KEY_F9:120,KEY_F10:121,KEY_F11:122,KEY_F12:123,KEY_F13:124,KEY_F14:125,KEY_F15:126,KEY_NUM_LOCK:144,KEY_SCROLL_LOCK:145};
this.revKeys=[];
for(var key in this.keys){
this.revKeys[this.keys[key]]=key;
}
this.fixEvent=function(evt,_23c){
if(!evt){
if(window["event"]){
evt=window.event;
}
}
if((evt["type"])&&(evt["type"].indexOf("key")==0)){
evt.keys=this.revKeys;
for(var key in this.keys){
evt[key]=this.keys[key];
}
if(evt["type"]=="keydown"&&dojo.render.html.ie){
switch(evt.keyCode){
case evt.KEY_SHIFT:
case evt.KEY_CTRL:
case evt.KEY_ALT:
case evt.KEY_CAPS_LOCK:
case evt.KEY_LEFT_WINDOW:
case evt.KEY_RIGHT_WINDOW:
case evt.KEY_SELECT:
case evt.KEY_NUM_LOCK:
case evt.KEY_SCROLL_LOCK:
case evt.KEY_NUMPAD_0:
case evt.KEY_NUMPAD_1:
case evt.KEY_NUMPAD_2:
case evt.KEY_NUMPAD_3:
case evt.KEY_NUMPAD_4:
case evt.KEY_NUMPAD_5:
case evt.KEY_NUMPAD_6:
case evt.KEY_NUMPAD_7:
case evt.KEY_NUMPAD_8:
case evt.KEY_NUMPAD_9:
case evt.KEY_NUMPAD_PERIOD:
break;
case evt.KEY_NUMPAD_MULTIPLY:
case evt.KEY_NUMPAD_PLUS:
case evt.KEY_NUMPAD_ENTER:
case evt.KEY_NUMPAD_MINUS:
case evt.KEY_NUMPAD_DIVIDE:
break;
case evt.KEY_PAUSE:
case evt.KEY_TAB:
case evt.KEY_BACKSPACE:
case evt.KEY_ENTER:
case evt.KEY_ESCAPE:
case evt.KEY_PAGE_UP:
case evt.KEY_PAGE_DOWN:
case evt.KEY_END:
case evt.KEY_HOME:
case evt.KEY_LEFT_ARROW:
case evt.KEY_UP_ARROW:
case evt.KEY_RIGHT_ARROW:
case evt.KEY_DOWN_ARROW:
case evt.KEY_INSERT:
case evt.KEY_DELETE:
case evt.KEY_F1:
case evt.KEY_F2:
case evt.KEY_F3:
case evt.KEY_F4:
case evt.KEY_F5:
case evt.KEY_F6:
case evt.KEY_F7:
case evt.KEY_F8:
case evt.KEY_F9:
case evt.KEY_F10:
case evt.KEY_F11:
case evt.KEY_F12:
case evt.KEY_F12:
case evt.KEY_F13:
case evt.KEY_F14:
case evt.KEY_F15:
case evt.KEY_CLEAR:
case evt.KEY_HELP:
evt.key=evt.keyCode;
break;
default:
if(evt.ctrlKey||evt.altKey){
var _23e=evt.keyCode;
if(_23e>=65&&_23e<=90&&evt.shiftKey==false){
_23e+=32;
}
if(_23e>=1&&_23e<=26&&evt.ctrlKey){
_23e+=96;
}
evt.key=String.fromCharCode(_23e);
}
}
}else{
if(evt["type"]=="keypress"){
if(dojo.render.html.opera){
if(evt.which==0){
evt.key=evt.keyCode;
}else{
if(evt.which>0){
switch(evt.which){
case evt.KEY_SHIFT:
case evt.KEY_CTRL:
case evt.KEY_ALT:
case evt.KEY_CAPS_LOCK:
case evt.KEY_NUM_LOCK:
case evt.KEY_SCROLL_LOCK:
break;
case evt.KEY_PAUSE:
case evt.KEY_TAB:
case evt.KEY_BACKSPACE:
case evt.KEY_ENTER:
case evt.KEY_ESCAPE:
evt.key=evt.which;
break;
default:
var _23e=evt.which;
if((evt.ctrlKey||evt.altKey||evt.metaKey)&&(evt.which>=65&&evt.which<=90&&evt.shiftKey==false)){
_23e+=32;
}
evt.key=String.fromCharCode(_23e);
}
}
}
}else{
if(dojo.render.html.ie){
if(!evt.ctrlKey&&!evt.altKey&&evt.keyCode>=evt.KEY_SPACE){
evt.key=String.fromCharCode(evt.keyCode);
}
}else{
if(dojo.render.html.safari){
switch(evt.keyCode){
case 63232:
evt.key=evt.KEY_UP_ARROW;
break;
case 63233:
evt.key=evt.KEY_DOWN_ARROW;
break;
case 63234:
evt.key=evt.KEY_LEFT_ARROW;
break;
case 63235:
evt.key=evt.KEY_RIGHT_ARROW;
break;
default:
evt.key=evt.charCode>0?String.fromCharCode(evt.charCode):evt.keyCode;
}
}else{
evt.key=evt.charCode>0?String.fromCharCode(evt.charCode):evt.keyCode;
}
}
}
}
}
}
if(dojo.render.html.ie){
if(!evt.target){
evt.target=evt.srcElement;
}
if(!evt.currentTarget){
evt.currentTarget=(_23c?_23c:evt.srcElement);
}
if(!evt.layerX){
evt.layerX=evt.offsetX;
}
if(!evt.layerY){
evt.layerY=evt.offsetY;
}
var doc=(evt.srcElement&&evt.srcElement.ownerDocument)?evt.srcElement.ownerDocument:document;
var _240=((dojo.render.html.ie55)||(doc["compatMode"]=="BackCompat"))?doc.body:doc.documentElement;
if(!evt.pageX){
evt.pageX=evt.clientX+(_240.scrollLeft||0);
}
if(!evt.pageY){
evt.pageY=evt.clientY+(_240.scrollTop||0);
}
if(evt.type=="mouseover"){
evt.relatedTarget=evt.fromElement;
}
if(evt.type=="mouseout"){
evt.relatedTarget=evt.toElement;
}
this.currentEvent=evt;
evt.callListener=this.callListener;
evt.stopPropagation=this._stopPropagation;
evt.preventDefault=this._preventDefault;
}
return evt;
};
this.stopEvent=function(evt){
if(window.event){
evt.returnValue=false;
evt.cancelBubble=true;
}else{
evt.preventDefault();
evt.stopPropagation();
}
};
};
dojo.provide("dojo.event.*");
dojo.provide("dojo.event");
dojo.deprecated("dojo.event","replaced by dojo.event.*","0.5");
dojo.provide("dojo.string.common");
dojo.string.trim=function(str,wh){
if(!str.replace){
return str;
}
if(!str.length){
return str;
}
var re=(wh>0)?(/^\s+/):(wh<0)?(/\s+$/):(/^\s+|\s+$/g);
return str.replace(re,"");
};
dojo.string.trimStart=function(str){
return dojo.string.trim(str,1);
};
dojo.string.trimEnd=function(str){
return dojo.string.trim(str,-1);
};
dojo.string.repeat=function(str,_248,_249){
var out="";
for(var i=0;i<_248;i++){
out+=str;
if(_249&&i<_248-1){
out+=_249;
}
}
return out;
};
dojo.string.pad=function(str,len,c,dir){
var out=String(str);
if(!c){
c="0";
}
if(!dir){
dir=1;
}
while(out.length<len){
if(dir>0){
out=c+out;
}else{
out+=c;
}
}
return out;
};
dojo.string.padLeft=function(str,len,c){
return dojo.string.pad(str,len,c,1);
};
dojo.string.padRight=function(str,len,c){
return dojo.string.pad(str,len,c,-1);
};
dojo.provide("dojo.string.extras");
dojo.string.substituteParams=function(_257,hash){
var map=(typeof hash=="object")?hash:dojo.lang.toArray(arguments,1);
return _257.replace(/\%\{(\w+)\}/g,function(_25a,key){
if(typeof (map[key])!="undefined"&&map[key]!=null){
return map[key];
}
dojo.raise("Substitution not found: "+key);
});
};
dojo.string.capitalize=function(str){
if(!dojo.lang.isString(str)){
return "";
}
if(arguments.length==0){
str=this;
}
var _25d=str.split(" ");
for(var i=0;i<_25d.length;i++){
_25d[i]=_25d[i].charAt(0).toUpperCase()+_25d[i].substring(1);
}
return _25d.join(" ");
};
dojo.string.isBlank=function(str){
if(!dojo.lang.isString(str)){
return true;
}
return (dojo.string.trim(str).length==0);
};
dojo.string.encodeAscii=function(str){
if(!dojo.lang.isString(str)){
return str;
}
var ret="";
var _262=escape(str);
var _263,re=/%u([0-9A-F]{4})/i;
while((_263=_262.match(re))){
var num=Number("0x"+_263[1]);
var _266=escape("&#"+num+";");
ret+=_262.substring(0,_263.index)+_266;
_262=_262.substring(_263.index+_263[0].length);
}
ret+=_262.replace(/\+/g,"%2B");
return ret;
};
dojo.string.escape=function(type,str){
var args=dojo.lang.toArray(arguments,1);
switch(type.toLowerCase()){
case "xml":
case "html":
case "xhtml":
return dojo.string.escapeXml.apply(this,args);
case "sql":
return dojo.string.escapeSql.apply(this,args);
case "regexp":
case "regex":
return dojo.string.escapeRegExp.apply(this,args);
case "javascript":
case "jscript":
case "js":
return dojo.string.escapeJavaScript.apply(this,args);
case "ascii":
return dojo.string.encodeAscii.apply(this,args);
default:
return str;
}
};
dojo.string.escapeXml=function(str,_26b){
str=str.replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;").replace(/"/gm,"&quot;");
if(!_26b){
str=str.replace(/'/gm,"&#39;");
}
return str;
};
dojo.string.escapeSql=function(str){
return str.replace(/'/gm,"''");
};
dojo.string.escapeRegExp=function(str){
return str.replace(/\\/gm,"\\\\").replace(/([\f\b\n\t\r[\^$|?*+(){}])/gm,"\\$1");
};
dojo.string.escapeJavaScript=function(str){
return str.replace(/(["'\f\b\n\t\r])/gm,"\\$1");
};
dojo.string.escapeString=function(str){
return ("\""+str.replace(/(["\\])/g,"\\$1")+"\"").replace(/[\f]/g,"\\f").replace(/[\b]/g,"\\b").replace(/[\n]/g,"\\n").replace(/[\t]/g,"\\t").replace(/[\r]/g,"\\r");
};
dojo.string.summary=function(str,len){
if(!len||str.length<=len){
return str;
}
return str.substring(0,len).replace(/\.+$/,"")+"...";
};
dojo.string.endsWith=function(str,end,_274){
if(_274){
str=str.toLowerCase();
end=end.toLowerCase();
}
if((str.length-end.length)<0){
return false;
}
return str.lastIndexOf(end)==str.length-end.length;
};
dojo.string.endsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.endsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.startsWith=function(str,_278,_279){
if(_279){
str=str.toLowerCase();
_278=_278.toLowerCase();
}
return str.indexOf(_278)==0;
};
dojo.string.startsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.startsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.has=function(str){
for(var i=1;i<arguments.length;i++){
if(str.indexOf(arguments[i])>-1){
return true;
}
}
return false;
};
dojo.string.normalizeNewlines=function(text,_27f){
if(_27f=="\n"){
text=text.replace(/\r\n/g,"\n");
text=text.replace(/\r/g,"\n");
}else{
if(_27f=="\r"){
text=text.replace(/\r\n/g,"\r");
text=text.replace(/\n/g,"\r");
}else{
text=text.replace(/([^\r])\n/g,"$1\r\n").replace(/\r([^\n])/g,"\r\n$1");
}
}
return text;
};
dojo.string.splitEscaped=function(str,_281){
var _282=[];
for(var i=0,_284=0;i<str.length;i++){
if(str.charAt(i)=="\\"){
i++;
continue;
}
if(str.charAt(i)==_281){
_282.push(str.substring(_284,i));
_284=i+1;
}
}
_282.push(str.substr(_284));
return _282;
};
dojo.provide("dojo.string");
dojo.provide("dojo.io.common");
dojo.io.transports=[];
dojo.io.hdlrFuncNames=["load","error","timeout"];
dojo.io.Request=function(url,_286,_287,_288){
if((arguments.length==1)&&(arguments[0].constructor==Object)){
this.fromKwArgs(arguments[0]);
}else{
this.url=url;
if(_286){
this.mimetype=_286;
}
if(_287){
this.transport=_287;
}
if(arguments.length>=4){
this.changeUrl=_288;
}
}
};
dojo.lang.extend(dojo.io.Request,{url:"",mimetype:"text/plain",method:"GET",content:undefined,transport:undefined,changeUrl:undefined,formNode:undefined,sync:false,bindSuccess:false,useCache:false,preventCache:false,load:function(type,data,_28b,_28c){
},error:function(type,_28e,_28f,_290){
},timeout:function(type,_292,_293,_294){
},handle:function(type,data,_297,_298){
},timeoutSeconds:0,abort:function(){
},fromKwArgs:function(_299){
if(_299["url"]){
_299.url=_299.url.toString();
}
if(_299["formNode"]){
_299.formNode=dojo.byId(_299.formNode);
}
if(!_299["method"]&&_299["formNode"]&&_299["formNode"].method){
_299.method=_299["formNode"].method;
}
if(!_299["handle"]&&_299["handler"]){
_299.handle=_299.handler;
}
if(!_299["load"]&&_299["loaded"]){
_299.load=_299.loaded;
}
if(!_299["changeUrl"]&&_299["changeURL"]){
_299.changeUrl=_299.changeURL;
}
_299.encoding=dojo.lang.firstValued(_299["encoding"],djConfig["bindEncoding"],"");
_299.sendTransport=dojo.lang.firstValued(_299["sendTransport"],djConfig["ioSendTransport"],false);
var _29a=dojo.lang.isFunction;
for(var x=0;x<dojo.io.hdlrFuncNames.length;x++){
var fn=dojo.io.hdlrFuncNames[x];
if(_299[fn]&&_29a(_299[fn])){
continue;
}
if(_299["handle"]&&_29a(_299["handle"])){
_299[fn]=_299.handle;
}
}
dojo.lang.mixin(this,_299);
}});
dojo.io.Error=function(msg,type,num){
this.message=msg;
this.type=type||"unknown";
this.number=num||0;
};
dojo.io.transports.addTransport=function(name){
this.push(name);
this[name]=dojo.io[name];
};
dojo.io.bind=function(_2a1){
if(!(_2a1 instanceof dojo.io.Request)){
try{
_2a1=new dojo.io.Request(_2a1);
}
catch(e){
dojo.debug(e);
}
}
var _2a2="";
if(_2a1["transport"]){
_2a2=_2a1["transport"];
if(!this[_2a2]){
dojo.io.sendBindError(_2a1,"No dojo.io.bind() transport with name '"+_2a1["transport"]+"'.");
return _2a1;
}
if(!this[_2a2].canHandle(_2a1)){
dojo.io.sendBindError(_2a1,"dojo.io.bind() transport with name '"+_2a1["transport"]+"' cannot handle this type of request.");
return _2a1;
}
}else{
for(var x=0;x<dojo.io.transports.length;x++){
var tmp=dojo.io.transports[x];
if((this[tmp])&&(this[tmp].canHandle(_2a1))){
_2a2=tmp;
break;
}
}
if(_2a2==""){
dojo.io.sendBindError(_2a1,"None of the loaded transports for dojo.io.bind()"+" can handle the request.");
return _2a1;
}
}
this[_2a2].bind(_2a1);
_2a1.bindSuccess=true;
return _2a1;
};
dojo.io.sendBindError=function(_2a5,_2a6){
if((typeof _2a5.error=="function"||typeof _2a5.handle=="function")&&(typeof setTimeout=="function"||typeof setTimeout=="object")){
var _2a7=new dojo.io.Error(_2a6);
setTimeout(function(){
_2a5[(typeof _2a5.error=="function")?"error":"handle"]("error",_2a7,null,_2a5);
},50);
}else{
dojo.raise(_2a6);
}
};
dojo.io.queueBind=function(_2a8){
if(!(_2a8 instanceof dojo.io.Request)){
try{
_2a8=new dojo.io.Request(_2a8);
}
catch(e){
dojo.debug(e);
}
}
var _2a9=_2a8.load;
_2a8.load=function(){
dojo.io._queueBindInFlight=false;
var ret=_2a9.apply(this,arguments);
dojo.io._dispatchNextQueueBind();
return ret;
};
var _2ab=_2a8.error;
_2a8.error=function(){
dojo.io._queueBindInFlight=false;
var ret=_2ab.apply(this,arguments);
dojo.io._dispatchNextQueueBind();
return ret;
};
dojo.io._bindQueue.push(_2a8);
dojo.io._dispatchNextQueueBind();
return _2a8;
};
dojo.io._dispatchNextQueueBind=function(){
if(!dojo.io._queueBindInFlight){
dojo.io._queueBindInFlight=true;
if(dojo.io._bindQueue.length>0){
dojo.io.bind(dojo.io._bindQueue.shift());
}else{
dojo.io._queueBindInFlight=false;
}
}
};
dojo.io._bindQueue=[];
dojo.io._queueBindInFlight=false;
dojo.io.argsFromMap=function(map,_2ae,last){
var enc=/utf/i.test(_2ae||"")?encodeURIComponent:dojo.string.encodeAscii;
var _2b1=[];
var _2b2=new Object();
for(var name in map){
var _2b4=function(elt){
var val=enc(name)+"="+enc(elt);
_2b1[(last==name)?"push":"unshift"](val);
};
if(!_2b2[name]){
var _2b7=map[name];
if(dojo.lang.isArray(_2b7)){
dojo.lang.forEach(_2b7,_2b4);
}else{
_2b4(_2b7);
}
}
}
return _2b1.join("&");
};
dojo.io.setIFrameSrc=function(_2b8,src,_2ba){
try{
var r=dojo.render.html;
if(!_2ba){
if(r.safari){
_2b8.location=src;
}else{
frames[_2b8.name].location=src;
}
}else{
var idoc;
if(r.ie){
idoc=_2b8.contentWindow.document;
}else{
if(r.safari){
idoc=_2b8.document;
}else{
idoc=_2b8.contentWindow;
}
}
if(!idoc){
_2b8.location=src;
return;
}else{
idoc.location.replace(src);
}
}
}
catch(e){
dojo.debug(e);
dojo.debug("setIFrameSrc: "+e);
}
};
dojo.provide("dojo.dom");
dojo.dom.ELEMENT_NODE=1;
dojo.dom.ATTRIBUTE_NODE=2;
dojo.dom.TEXT_NODE=3;
dojo.dom.CDATA_SECTION_NODE=4;
dojo.dom.ENTITY_REFERENCE_NODE=5;
dojo.dom.ENTITY_NODE=6;
dojo.dom.PROCESSING_INSTRUCTION_NODE=7;
dojo.dom.COMMENT_NODE=8;
dojo.dom.DOCUMENT_NODE=9;
dojo.dom.DOCUMENT_TYPE_NODE=10;
dojo.dom.DOCUMENT_FRAGMENT_NODE=11;
dojo.dom.NOTATION_NODE=12;
dojo.dom.dojoml="http://www.dojotoolkit.org/2004/dojoml";
dojo.dom.xmlns={svg:"http://www.w3.org/2000/svg",smil:"http://www.w3.org/2001/SMIL20/",mml:"http://www.w3.org/1998/Math/MathML",cml:"http://www.xml-cml.org",xlink:"http://www.w3.org/1999/xlink",xhtml:"http://www.w3.org/1999/xhtml",xul:"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",xbl:"http://www.mozilla.org/xbl",fo:"http://www.w3.org/1999/XSL/Format",xsl:"http://www.w3.org/1999/XSL/Transform",xslt:"http://www.w3.org/1999/XSL/Transform",xi:"http://www.w3.org/2001/XInclude",xforms:"http://www.w3.org/2002/01/xforms",saxon:"http://icl.com/saxon",xalan:"http://xml.apache.org/xslt",xsd:"http://www.w3.org/2001/XMLSchema",dt:"http://www.w3.org/2001/XMLSchema-datatypes",xsi:"http://www.w3.org/2001/XMLSchema-instance",rdf:"http://www.w3.org/1999/02/22-rdf-syntax-ns#",rdfs:"http://www.w3.org/2000/01/rdf-schema#",dc:"http://purl.org/dc/elements/1.1/",dcq:"http://purl.org/dc/qualifiers/1.0","soap-env":"http://schemas.xmlsoap.org/soap/envelope/",wsdl:"http://schemas.xmlsoap.org/wsdl/",AdobeExtensions:"http://ns.adobe.com/AdobeSVGViewerExtensions/3.0/"};
dojo.dom.isNode=function(wh){
if(typeof Element=="function"){
try{
return wh instanceof Element;
}
catch(E){
}
}else{
return wh&&!isNaN(wh.nodeType);
}
};
dojo.dom.getUniqueId=function(){
var _2be=dojo.doc();
do{
var id="dj_unique_"+(++arguments.callee._idIncrement);
}while(_2be.getElementById(id));
return id;
};
dojo.dom.getUniqueId._idIncrement=0;
dojo.dom.firstElement=dojo.dom.getFirstChildElement=function(_2c0,_2c1){
var node=_2c0.firstChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.nextSibling;
}
if(_2c1&&node&&node.tagName&&node.tagName.toLowerCase()!=_2c1.toLowerCase()){
node=dojo.dom.nextElement(node,_2c1);
}
return node;
};
dojo.dom.lastElement=dojo.dom.getLastChildElement=function(_2c3,_2c4){
var node=_2c3.lastChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.previousSibling;
}
if(_2c4&&node&&node.tagName&&node.tagName.toLowerCase()!=_2c4.toLowerCase()){
node=dojo.dom.prevElement(node,_2c4);
}
return node;
};
dojo.dom.nextElement=dojo.dom.getNextSiblingElement=function(node,_2c7){
if(!node){
return null;
}
do{
node=node.nextSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_2c7&&_2c7.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.nextElement(node,_2c7);
}
return node;
};
dojo.dom.prevElement=dojo.dom.getPreviousSiblingElement=function(node,_2c9){
if(!node){
return null;
}
if(_2c9){
_2c9=_2c9.toLowerCase();
}
do{
node=node.previousSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_2c9&&_2c9.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.prevElement(node,_2c9);
}
return node;
};
dojo.dom.moveChildren=function(_2ca,_2cb,trim){
var _2cd=0;
if(trim){
while(_2ca.hasChildNodes()&&_2ca.firstChild.nodeType==dojo.dom.TEXT_NODE){
_2ca.removeChild(_2ca.firstChild);
}
while(_2ca.hasChildNodes()&&_2ca.lastChild.nodeType==dojo.dom.TEXT_NODE){
_2ca.removeChild(_2ca.lastChild);
}
}
while(_2ca.hasChildNodes()){
_2cb.appendChild(_2ca.firstChild);
_2cd++;
}
return _2cd;
};
dojo.dom.copyChildren=function(_2ce,_2cf,trim){
var _2d1=_2ce.cloneNode(true);
return this.moveChildren(_2d1,_2cf,trim);
};
dojo.dom.removeChildren=function(node){
var _2d3=node.childNodes.length;
while(node.hasChildNodes()){
node.removeChild(node.firstChild);
}
return _2d3;
};
dojo.dom.replaceChildren=function(node,_2d5){
dojo.dom.removeChildren(node);
node.appendChild(_2d5);
};
dojo.dom.removeNode=function(node){
if(node&&node.parentNode){
return node.parentNode.removeChild(node);
}
};
dojo.dom.getAncestors=function(node,_2d8,_2d9){
var _2da=[];
var _2db=(_2d8&&(_2d8 instanceof Function||typeof _2d8=="function"));
while(node){
if(!_2db||_2d8(node)){
_2da.push(node);
}
if(_2d9&&_2da.length>0){
return _2da[0];
}
node=node.parentNode;
}
if(_2d9){
return null;
}
return _2da;
};
dojo.dom.getAncestorsByTag=function(node,tag,_2de){
tag=tag.toLowerCase();
return dojo.dom.getAncestors(node,function(el){
return ((el.tagName)&&(el.tagName.toLowerCase()==tag));
},_2de);
};
dojo.dom.getFirstAncestorByTag=function(node,tag){
return dojo.dom.getAncestorsByTag(node,tag,true);
};
dojo.dom.isDescendantOf=function(node,_2e3,_2e4){
if(_2e4&&node){
node=node.parentNode;
}
while(node){
if(node==_2e3){
return true;
}
node=node.parentNode;
}
return false;
};
dojo.dom.innerXML=function(node){
if(node.innerXML){
return node.innerXML;
}else{
if(node.xml){
return node.xml;
}else{
if(typeof XMLSerializer!="undefined"){
return (new XMLSerializer()).serializeToString(node);
}
}
}
};
dojo.dom.createDocument=function(){
var doc=null;
var _2e7=dojo.doc();
if(!dj_undef("ActiveXObject")){
var _2e8=["MSXML2","Microsoft","MSXML","MSXML3"];
for(var i=0;i<_2e8.length;i++){
try{
doc=new ActiveXObject(_2e8[i]+".XMLDOM");
}
catch(e){
}
if(doc){
break;
}
}
}else{
if((_2e7.implementation)&&(_2e7.implementation.createDocument)){
doc=_2e7.implementation.createDocument("","",null);
}
}
return doc;
};
dojo.dom.createDocumentFromText=function(str,_2eb){
if(!_2eb){
_2eb="text/xml";
}
if(!dj_undef("DOMParser")){
var _2ec=new DOMParser();
return _2ec.parseFromString(str,_2eb);
}else{
if(!dj_undef("ActiveXObject")){
var _2ed=dojo.dom.createDocument();
if(_2ed){
_2ed.async=false;
_2ed.loadXML(str);
return _2ed;
}else{
dojo.debug("toXml didn't work?");
}
}else{
var _2ee=dojo.doc();
if(_2ee.createElement){
var tmp=_2ee.createElement("xml");
tmp.innerHTML=str;
if(_2ee.implementation&&_2ee.implementation.createDocument){
var _2f0=_2ee.implementation.createDocument("foo","",null);
for(var i=0;i<tmp.childNodes.length;i++){
_2f0.importNode(tmp.childNodes.item(i),true);
}
return _2f0;
}
return ((tmp.document)&&(tmp.document.firstChild?tmp.document.firstChild:tmp));
}
}
}
return null;
};
dojo.dom.prependChild=function(node,_2f3){
if(_2f3.firstChild){
_2f3.insertBefore(node,_2f3.firstChild);
}else{
_2f3.appendChild(node);
}
return true;
};
dojo.dom.insertBefore=function(node,ref,_2f6){
if(_2f6!=true&&(node===ref||node.nextSibling===ref)){
return false;
}
var _2f7=ref.parentNode;
_2f7.insertBefore(node,ref);
return true;
};
dojo.dom.insertAfter=function(node,ref,_2fa){
var pn=ref.parentNode;
if(ref==pn.lastChild){
if((_2fa!=true)&&(node===ref)){
return false;
}
pn.appendChild(node);
}else{
return this.insertBefore(node,ref.nextSibling,_2fa);
}
return true;
};
dojo.dom.insertAtPosition=function(node,ref,_2fe){
if((!node)||(!ref)||(!_2fe)){
return false;
}
switch(_2fe.toLowerCase()){
case "before":
return dojo.dom.insertBefore(node,ref);
case "after":
return dojo.dom.insertAfter(node,ref);
case "first":
if(ref.firstChild){
return dojo.dom.insertBefore(node,ref.firstChild);
}else{
ref.appendChild(node);
return true;
}
break;
default:
ref.appendChild(node);
return true;
}
};
dojo.dom.insertAtIndex=function(node,_300,_301){
var _302=_300.childNodes;
if(!_302.length){
_300.appendChild(node);
return true;
}
var _303=null;
for(var i=0;i<_302.length;i++){
var _305=_302.item(i)["getAttribute"]?parseInt(_302.item(i).getAttribute("dojoinsertionindex")):-1;
if(_305<_301){
_303=_302.item(i);
}
}
if(_303){
return dojo.dom.insertAfter(node,_303);
}else{
return dojo.dom.insertBefore(node,_302.item(0));
}
};
dojo.dom.textContent=function(node,text){
if(arguments.length>1){
var _308=dojo.doc();
dojo.dom.replaceChildren(node,_308.createTextNode(text));
return text;
}else{
if(node.textContent!=undefined){
return node.textContent;
}
var _309="";
if(node==null){
return _309;
}
for(var i=0;i<node.childNodes.length;i++){
switch(node.childNodes[i].nodeType){
case 1:
case 5:
_309+=dojo.dom.textContent(node.childNodes[i]);
break;
case 3:
case 2:
case 4:
_309+=node.childNodes[i].nodeValue;
break;
default:
break;
}
}
return _309;
}
};
dojo.dom.hasParent=function(node){
return node&&node.parentNode&&dojo.dom.isNode(node.parentNode);
};
dojo.dom.isTag=function(node){
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName==String(arguments[i])){
return String(arguments[i]);
}
}
}
return "";
};
dojo.dom.setAttributeNS=function(elem,_30f,_310,_311){
if(elem==null||((elem==undefined)&&(typeof elem=="undefined"))){
dojo.raise("No element given to dojo.dom.setAttributeNS");
}
if(!((elem.setAttributeNS==undefined)&&(typeof elem.setAttributeNS=="undefined"))){
elem.setAttributeNS(_30f,_310,_311);
}else{
var _312=elem.ownerDocument;
var _313=_312.createNode(2,_310,_30f);
_313.nodeValue=_311;
elem.setAttributeNode(_313);
}
};
dojo.provide("dojo.undo.browser");
try{
if((!djConfig["preventBackButtonFix"])&&(!dojo.hostenv.post_load_)){
document.write("<iframe style='border: 0px; width: 1px; height: 1px; position: absolute; bottom: 0px; right: 0px; visibility: visible;' name='djhistory' id='djhistory' src='"+(dojo.hostenv.getBaseScriptUri()+"iframe_history.html")+"'></iframe>");
}
}
catch(e){
}
if(dojo.render.html.opera){
dojo.debug("Opera is not supported with dojo.undo.browser, so back/forward detection will not work.");
}
dojo.undo.browser={initialHref:window.location.href,initialHash:window.location.hash,moveForward:false,historyStack:[],forwardStack:[],historyIframe:null,bookmarkAnchor:null,locationTimer:null,setInitialState:function(args){
this.initialState=this._createState(this.initialHref,args,this.initialHash);
},addToHistory:function(args){
this.forwardStack=[];
var hash=null;
var url=null;
if(!this.historyIframe){
this.historyIframe=window.frames["djhistory"];
}
if(!this.bookmarkAnchor){
this.bookmarkAnchor=document.createElement("a");
dojo.body().appendChild(this.bookmarkAnchor);
this.bookmarkAnchor.style.display="none";
}
if(args["changeUrl"]){
hash="#"+((args["changeUrl"]!==true)?args["changeUrl"]:(new Date()).getTime());
if(this.historyStack.length==0&&this.initialState.urlHash==hash){
this.initialState=this._createState(url,args,hash);
return;
}else{
if(this.historyStack.length>0&&this.historyStack[this.historyStack.length-1].urlHash==hash){
this.historyStack[this.historyStack.length-1]=this._createState(url,args,hash);
return;
}
}
this.changingUrl=true;
setTimeout("window.location.href = '"+hash+"'; dojo.undo.browser.changingUrl = false;",1);
this.bookmarkAnchor.href=hash;
if(dojo.render.html.ie){
url=this._loadIframeHistory();
var _318=args["back"]||args["backButton"]||args["handle"];
var tcb=function(_31a){
if(window.location.hash!=""){
setTimeout("window.location.href = '"+hash+"';",1);
}
_318.apply(this,[_31a]);
};
if(args["back"]){
args.back=tcb;
}else{
if(args["backButton"]){
args.backButton=tcb;
}else{
if(args["handle"]){
args.handle=tcb;
}
}
}
var _31b=args["forward"]||args["forwardButton"]||args["handle"];
var tfw=function(_31d){
if(window.location.hash!=""){
window.location.href=hash;
}
if(_31b){
_31b.apply(this,[_31d]);
}
};
if(args["forward"]){
args.forward=tfw;
}else{
if(args["forwardButton"]){
args.forwardButton=tfw;
}else{
if(args["handle"]){
args.handle=tfw;
}
}
}
}else{
if(dojo.render.html.moz){
if(!this.locationTimer){
this.locationTimer=setInterval("dojo.undo.browser.checkLocation();",200);
}
}
}
}else{
url=this._loadIframeHistory();
}
this.historyStack.push(this._createState(url,args,hash));
},checkLocation:function(){
if(!this.changingUrl){
var hsl=this.historyStack.length;
if((window.location.hash==this.initialHash||window.location.href==this.initialHref)&&(hsl==1)){
this.handleBackButton();
return;
}
if(this.forwardStack.length>0){
if(this.forwardStack[this.forwardStack.length-1].urlHash==window.location.hash){
this.handleForwardButton();
return;
}
}
if((hsl>=2)&&(this.historyStack[hsl-2])){
if(this.historyStack[hsl-2].urlHash==window.location.hash){
this.handleBackButton();
return;
}
}
}
},iframeLoaded:function(evt,_320){
if(!dojo.render.html.opera){
var _321=this._getUrlQuery(_320.href);
if(_321==null){
if(this.historyStack.length==1){
this.handleBackButton();
}
return;
}
if(this.moveForward){
this.moveForward=false;
return;
}
if(this.historyStack.length>=2&&_321==this._getUrlQuery(this.historyStack[this.historyStack.length-2].url)){
this.handleBackButton();
}else{
if(this.forwardStack.length>0&&_321==this._getUrlQuery(this.forwardStack[this.forwardStack.length-1].url)){
this.handleForwardButton();
}
}
}
},handleBackButton:function(){
var _322=this.historyStack.pop();
if(!_322){
return;
}
var last=this.historyStack[this.historyStack.length-1];
if(!last&&this.historyStack.length==0){
last=this.initialState;
}
if(last){
if(last.kwArgs["back"]){
last.kwArgs["back"]();
}else{
if(last.kwArgs["backButton"]){
last.kwArgs["backButton"]();
}else{
if(last.kwArgs["handle"]){
last.kwArgs.handle("back");
}
}
}
}
this.forwardStack.push(_322);
},handleForwardButton:function(){
var last=this.forwardStack.pop();
if(!last){
return;
}
if(last.kwArgs["forward"]){
last.kwArgs.forward();
}else{
if(last.kwArgs["forwardButton"]){
last.kwArgs.forwardButton();
}else{
if(last.kwArgs["handle"]){
last.kwArgs.handle("forward");
}
}
}
this.historyStack.push(last);
},_createState:function(url,args,hash){
return {"url":url,"kwArgs":args,"urlHash":hash};
},_getUrlQuery:function(url){
var _329=url.split("?");
if(_329.length<2){
return null;
}else{
return _329[1];
}
},_loadIframeHistory:function(){
var url=dojo.hostenv.getBaseScriptUri()+"iframe_history.html?"+(new Date()).getTime();
this.moveForward=true;
dojo.io.setIFrameSrc(this.historyIframe,url,false);
return url;
}};
dojo.provide("dojo.io.BrowserIO");
dojo.io.checkChildrenForFile=function(node){
var _32c=false;
var _32d=node.getElementsByTagName("input");
dojo.lang.forEach(_32d,function(_32e){
if(_32c){
return;
}
if(_32e.getAttribute("type")=="file"){
_32c=true;
}
});
return _32c;
};
dojo.io.formHasFile=function(_32f){
return dojo.io.checkChildrenForFile(_32f);
};
dojo.io.updateNode=function(node,_331){
node=dojo.byId(node);
var args=_331;
if(dojo.lang.isString(_331)){
args={url:_331};
}
args.mimetype="text/html";
args.load=function(t,d,e){
while(node.firstChild){
if(dojo["event"]){
try{
dojo.event.browser.clean(node.firstChild);
}
catch(e){
}
}
node.removeChild(node.firstChild);
}
node.innerHTML=d;
};
dojo.io.bind(args);
};
dojo.io.formFilter=function(node){
var type=(node.type||"").toLowerCase();
return !node.disabled&&node.name&&!dojo.lang.inArray(["file","submit","image","reset","button"],type);
};
dojo.io.encodeForm=function(_338,_339,_33a){
if((!_338)||(!_338.tagName)||(!_338.tagName.toLowerCase()=="form")){
dojo.raise("Attempted to encode a non-form element.");
}
if(!_33a){
_33a=dojo.io.formFilter;
}
var enc=/utf/i.test(_339||"")?encodeURIComponent:dojo.string.encodeAscii;
var _33c=[];
for(var i=0;i<_338.elements.length;i++){
var elm=_338.elements[i];
if(!elm||elm.tagName.toLowerCase()=="fieldset"||!_33a(elm)){
continue;
}
var name=enc(elm.name);
var type=elm.type.toLowerCase();
if(type=="select-multiple"){
for(var j=0;j<elm.options.length;j++){
if(elm.options[j].selected){
_33c.push(name+"="+enc(elm.options[j].value));
}
}
}else{
if(dojo.lang.inArray(["radio","checkbox"],type)){
if(elm.checked){
_33c.push(name+"="+enc(elm.value));
}
}else{
_33c.push(name+"="+enc(elm.value));
}
}
}
var _342=_338.getElementsByTagName("input");
for(var i=0;i<_342.length;i++){
var _343=_342[i];
if(_343.type.toLowerCase()=="image"&&_343.form==_338&&_33a(_343)){
var name=enc(_343.name);
_33c.push(name+"="+enc(_343.value));
_33c.push(name+".x=0");
_33c.push(name+".y=0");
}
}
return _33c.join("&")+"&";
};
dojo.io.FormBind=function(args){
this.bindArgs={};
if(args&&args.formNode){
this.init(args);
}else{
if(args){
this.init({formNode:args});
}
}
};
dojo.lang.extend(dojo.io.FormBind,{form:null,bindArgs:null,clickedButton:null,init:function(args){
var form=dojo.byId(args.formNode);
if(!form||!form.tagName||form.tagName.toLowerCase()!="form"){
throw new Error("FormBind: Couldn't apply, invalid form");
}else{
if(this.form==form){
return;
}else{
if(this.form){
throw new Error("FormBind: Already applied to a form");
}
}
}
dojo.lang.mixin(this.bindArgs,args);
this.form=form;
this.connect(form,"onsubmit","submit");
for(var i=0;i<form.elements.length;i++){
var node=form.elements[i];
if(node&&node.type&&dojo.lang.inArray(["submit","button"],node.type.toLowerCase())){
this.connect(node,"onclick","click");
}
}
var _349=form.getElementsByTagName("input");
for(var i=0;i<_349.length;i++){
var _34a=_349[i];
if(_34a.type.toLowerCase()=="image"&&_34a.form==form){
this.connect(_34a,"onclick","click");
}
}
},onSubmit:function(form){
return true;
},submit:function(e){
e.preventDefault();
if(this.onSubmit(this.form)){
dojo.io.bind(dojo.lang.mixin(this.bindArgs,{formFilter:dojo.lang.hitch(this,"formFilter")}));
}
},click:function(e){
var node=e.currentTarget;
if(node.disabled){
return;
}
this.clickedButton=node;
},formFilter:function(node){
var type=(node.type||"").toLowerCase();
var _351=false;
if(node.disabled||!node.name){
_351=false;
}else{
if(dojo.lang.inArray(["submit","button","image"],type)){
if(!this.clickedButton){
this.clickedButton=node;
}
_351=node==this.clickedButton;
}else{
_351=!dojo.lang.inArray(["file","submit","reset","button"],type);
}
}
return _351;
},connect:function(_352,_353,_354){
if(dojo.evalObjPath("dojo.event.connect")){
dojo.event.connect(_352,_353,this,_354);
}else{
var fcn=dojo.lang.hitch(this,_354);
_352[_353]=function(e){
if(!e){
e=window.event;
}
if(!e.currentTarget){
e.currentTarget=e.srcElement;
}
if(!e.preventDefault){
e.preventDefault=function(){
window.event.returnValue=false;
};
}
fcn(e);
};
}
}});
dojo.io.XMLHTTPTransport=new function(){
var _357=this;
var _358={};
this.useCache=false;
this.preventCache=false;
function getCacheKey(url,_35a,_35b){
return url+"|"+_35a+"|"+_35b.toLowerCase();
}
function addToCache(url,_35d,_35e,http){
_358[getCacheKey(url,_35d,_35e)]=http;
}
function getFromCache(url,_361,_362){
return _358[getCacheKey(url,_361,_362)];
}
this.clearCache=function(){
_358={};
};
function doLoad(_363,http,url,_366,_367){
if(((http.status>=200)&&(http.status<300))||(http.status==304)||(location.protocol=="file:"&&(http.status==0||http.status==undefined))||(location.protocol=="chrome:"&&(http.status==0||http.status==undefined))){
var ret;
if(_363.method.toLowerCase()=="head"){
var _369=http.getAllResponseHeaders();
ret={};
ret.toString=function(){
return _369;
};
var _36a=_369.split(/[\r\n]+/g);
for(var i=0;i<_36a.length;i++){
var pair=_36a[i].match(/^([^:]+)\s*:\s*(.+)$/i);
if(pair){
ret[pair[1]]=pair[2];
}
}
}else{
if(_363.mimetype=="text/javascript"){
try{
ret=dj_eval(http.responseText);
}
catch(e){
dojo.debug(e);
dojo.debug(http.responseText);
ret=null;
}
}else{
if(_363.mimetype=="text/json"||_363.mimetype=="application/json"){
try{
ret=dj_eval("("+http.responseText+")");
}
catch(e){
dojo.debug(e);
dojo.debug(http.responseText);
ret=false;
}
}else{
if((_363.mimetype=="application/xml")||(_363.mimetype=="text/xml")){
ret=http.responseXML;
if(!ret||typeof ret=="string"||!http.getResponseHeader("Content-Type")){
ret=dojo.dom.createDocumentFromText(http.responseText);
}
}else{
ret=http.responseText;
}
}
}
}
if(_367){
addToCache(url,_366,_363.method,http);
}
_363[(typeof _363.load=="function")?"load":"handle"]("load",ret,http,_363);
}else{
var _36d=new dojo.io.Error("XMLHttpTransport Error: "+http.status+" "+http.statusText);
_363[(typeof _363.error=="function")?"error":"handle"]("error",_36d,http,_363);
}
}
function setHeaders(http,_36f){
if(_36f["headers"]){
for(var _370 in _36f["headers"]){
if(_370.toLowerCase()=="content-type"&&!_36f["contentType"]){
_36f["contentType"]=_36f["headers"][_370];
}else{
http.setRequestHeader(_370,_36f["headers"][_370]);
}
}
}
}
this.inFlight=[];
this.inFlightTimer=null;
this.startWatchingInFlight=function(){
if(!this.inFlightTimer){
this.inFlightTimer=setTimeout("dojo.io.XMLHTTPTransport.watchInFlight();",10);
}
};
this.watchInFlight=function(){
var now=null;
if(!dojo.hostenv._blockAsync&&!_357._blockAsync){
for(var x=this.inFlight.length-1;x>=0;x--){
try{
var tif=this.inFlight[x];
if(!tif||tif.http._aborted||!tif.http.readyState){
this.inFlight.splice(x,1);
continue;
}
if(4==tif.http.readyState){
this.inFlight.splice(x,1);
doLoad(tif.req,tif.http,tif.url,tif.query,tif.useCache);
}else{
if(tif.startTime){
if(!now){
now=(new Date()).getTime();
}
if(tif.startTime+(tif.req.timeoutSeconds*1000)<now){
if(typeof tif.http.abort=="function"){
tif.http.abort();
}
this.inFlight.splice(x,1);
tif.req[(typeof tif.req.timeout=="function")?"timeout":"handle"]("timeout",null,tif.http,tif.req);
}
}
}
}
catch(e){
try{
var _374=new dojo.io.Error("XMLHttpTransport.watchInFlight Error: "+e);
tif.req[(typeof tif.req.error=="function")?"error":"handle"]("error",_374,tif.http,tif.req);
}
catch(e2){
dojo.debug("XMLHttpTransport error callback failed: "+e2);
}
}
}
}
clearTimeout(this.inFlightTimer);
if(this.inFlight.length==0){
this.inFlightTimer=null;
return;
}
this.inFlightTimer=setTimeout("dojo.io.XMLHTTPTransport.watchInFlight();",10);
};
var _375=dojo.hostenv.getXmlhttpObject()?true:false;
this.canHandle=function(_376){
return _375&&dojo.lang.inArray(["text/plain","text/html","application/xml","text/xml","text/javascript","text/json","application/json"],(_376["mimetype"].toLowerCase()||""))&&!(_376["formNode"]&&dojo.io.formHasFile(_376["formNode"]));
};
this.multipartBoundary="45309FFF-BD65-4d50-99C9-36986896A96F";
this.bind=function(_377){
if(!_377["url"]){
if(!_377["formNode"]&&(_377["backButton"]||_377["back"]||_377["changeUrl"]||_377["watchForURL"])&&(!djConfig.preventBackButtonFix)){
dojo.deprecated("Using dojo.io.XMLHTTPTransport.bind() to add to browser history without doing an IO request","Use dojo.undo.browser.addToHistory() instead.","0.4");
dojo.undo.browser.addToHistory(_377);
return true;
}
}
var url=_377.url;
var _379="";
if(_377["formNode"]){
var ta=_377.formNode.getAttribute("action");
if((ta)&&(!_377["url"])){
url=ta;
}
var tp=_377.formNode.getAttribute("method");
if((tp)&&(!_377["method"])){
_377.method=tp;
}
_379+=dojo.io.encodeForm(_377.formNode,_377.encoding,_377["formFilter"]);
}
if(url.indexOf("#")>-1){
dojo.debug("Warning: dojo.io.bind: stripping hash values from url:",url);
url=url.split("#")[0];
}
if(_377["file"]){
_377.method="post";
}
if(!_377["method"]){
_377.method="get";
}
if(_377.method.toLowerCase()=="get"){
_377.multipart=false;
}else{
if(_377["file"]){
_377.multipart=true;
}else{
if(!_377["multipart"]){
_377.multipart=false;
}
}
}
if(_377["backButton"]||_377["back"]||_377["changeUrl"]){
dojo.undo.browser.addToHistory(_377);
}
var _37c=_377["content"]||{};
if(_377.sendTransport){
_37c["dojo.transport"]="xmlhttp";
}
do{
if(_377.postContent){
_379=_377.postContent;
break;
}
if(_37c){
_379+=dojo.io.argsFromMap(_37c,_377.encoding);
}
if(_377.method.toLowerCase()=="get"||!_377.multipart){
break;
}
var t=[];
if(_379.length){
var q=_379.split("&");
for(var i=0;i<q.length;++i){
if(q[i].length){
var p=q[i].split("=");
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+p[0]+"\"","",p[1]);
}
}
}
if(_377.file){
if(dojo.lang.isArray(_377.file)){
for(var i=0;i<_377.file.length;++i){
var o=_377.file[i];
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+o.name+"\"; filename=\""+("fileName" in o?o.fileName:o.name)+"\"","Content-Type: "+("contentType" in o?o.contentType:"application/octet-stream"),"",o.content);
}
}else{
var o=_377.file;
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+o.name+"\"; filename=\""+("fileName" in o?o.fileName:o.name)+"\"","Content-Type: "+("contentType" in o?o.contentType:"application/octet-stream"),"",o.content);
}
}
if(t.length){
t.push("--"+this.multipartBoundary+"--","");
_379=t.join("\r\n");
}
}while(false);
var _382=_377["sync"]?false:true;
var _383=_377["preventCache"]||(this.preventCache==true&&_377["preventCache"]!=false);
var _384=_377["useCache"]==true||(this.useCache==true&&_377["useCache"]!=false);
if(!_383&&_384){
var _385=getFromCache(url,_379,_377.method);
if(_385){
doLoad(_377,_385,url,_379,false);
return;
}
}
var http=dojo.hostenv.getXmlhttpObject(_377);
var _387=false;
if(_382){
var _388=this.inFlight.push({"req":_377,"http":http,"url":url,"query":_379,"useCache":_384,"startTime":_377.timeoutSeconds?(new Date()).getTime():0});
this.startWatchingInFlight();
}else{
_357._blockAsync=true;
}
if(_377.method.toLowerCase()=="post"){
if(!_377.user){
http.open("POST",url,_382);
}else{
http.open("POST",url,_382,_377.user,_377.password);
}
setHeaders(http,_377);
http.setRequestHeader("Content-Type",_377.multipart?("multipart/form-data; boundary="+this.multipartBoundary):(_377.contentType||"application/x-www-form-urlencoded"));
try{
http.send(_379);
}
catch(e){
if(typeof http.abort=="function"){
http.abort();
}
doLoad(_377,{status:404},url,_379,_384);
}
}else{
var _389=url;
if(_379!=""){
_389+=(_389.indexOf("?")>-1?"&":"?")+_379;
}
if(_383){
_389+=(dojo.string.endsWithAny(_389,"?","&")?"":(_389.indexOf("?")>-1?"&":"?"))+"dojo.preventCache="+new Date().valueOf();
}
if(!_377.user){
http.open(_377.method.toUpperCase(),_389,_382);
}else{
http.open(_377.method.toUpperCase(),_389,_382,_377.user,_377.password);
}
setHeaders(http,_377);
try{
http.send(null);
}
catch(e){
if(typeof http.abort=="function"){
http.abort();
}
doLoad(_377,{status:404},url,_379,_384);
}
}
if(!_382){
doLoad(_377,http,url,_379,_384);
_357._blockAsync=false;
}
_377.abort=function(){
try{
http._aborted=true;
}
catch(e){
}
return http.abort();
};
return;
};
dojo.io.transports.addTransport("XMLHTTPTransport");
};
dojo.provide("dojo.io.cookie");
dojo.io.cookie.setCookie=function(name,_38b,days,path,_38e,_38f){
var _390=-1;
if(typeof days=="number"&&days>=0){
var d=new Date();
d.setTime(d.getTime()+(days*24*60*60*1000));
_390=d.toGMTString();
}
_38b=escape(_38b);
document.cookie=name+"="+_38b+";"+(_390!=-1?" expires="+_390+";":"")+(path?"path="+path:"")+(_38e?"; domain="+_38e:"")+(_38f?"; secure":"");
};
dojo.io.cookie.set=dojo.io.cookie.setCookie;
dojo.io.cookie.getCookie=function(name){
var idx=document.cookie.lastIndexOf(name+"=");
if(idx==-1){
return null;
}
var _394=document.cookie.substring(idx+name.length+1);
var end=_394.indexOf(";");
if(end==-1){
end=_394.length;
}
_394=_394.substring(0,end);
_394=unescape(_394);
return _394;
};
dojo.io.cookie.get=dojo.io.cookie.getCookie;
dojo.io.cookie.deleteCookie=function(name){
dojo.io.cookie.setCookie(name,"-",0);
};
dojo.io.cookie.setObjectCookie=function(name,obj,days,path,_39b,_39c,_39d){
if(arguments.length==5){
_39d=_39b;
_39b=null;
_39c=null;
}
var _39e=[],_39f,_3a0="";
if(!_39d){
_39f=dojo.io.cookie.getObjectCookie(name);
}
if(days>=0){
if(!_39f){
_39f={};
}
for(var prop in obj){
if(prop==null){
delete _39f[prop];
}else{
if(typeof obj[prop]=="string"||typeof obj[prop]=="number"){
_39f[prop]=obj[prop];
}
}
}
prop=null;
for(var prop in _39f){
_39e.push(escape(prop)+"="+escape(_39f[prop]));
}
_3a0=_39e.join("&");
}
dojo.io.cookie.setCookie(name,_3a0,days,path,_39b,_39c);
};
dojo.io.cookie.getObjectCookie=function(name){
var _3a3=null,_3a4=dojo.io.cookie.getCookie(name);
if(_3a4){
_3a3={};
var _3a5=_3a4.split("&");
for(var i=0;i<_3a5.length;i++){
var pair=_3a5[i].split("=");
var _3a8=pair[1];
if(isNaN(_3a8)){
_3a8=unescape(pair[1]);
}
_3a3[unescape(pair[0])]=_3a8;
}
}
return _3a3;
};
dojo.io.cookie.isSupported=function(){
if(typeof navigator.cookieEnabled!="boolean"){
dojo.io.cookie.setCookie("__TestingYourBrowserForCookieSupport__","CookiesAllowed",90,null);
var _3a9=dojo.io.cookie.getCookie("__TestingYourBrowserForCookieSupport__");
navigator.cookieEnabled=(_3a9=="CookiesAllowed");
if(navigator.cookieEnabled){
this.deleteCookie("__TestingYourBrowserForCookieSupport__");
}
}
return navigator.cookieEnabled;
};
if(!dojo.io.cookies){
dojo.io.cookies=dojo.io.cookie;
}
dojo.provide("dojo.io.*");
dojo.provide("dojo.io");
dojo.deprecated("dojo.io","replaced by dojo.io.*","0.5");
dojo.provide("dojo.AdapterRegistry");
dojo.AdapterRegistry=function(_3aa){
this.pairs=[];
this.returnWrappers=_3aa||false;
};
dojo.lang.extend(dojo.AdapterRegistry,{register:function(name,_3ac,wrap,_3ae,_3af){
var type=(_3af)?"unshift":"push";
this.pairs[type]([name,_3ac,wrap,_3ae]);
},match:function(){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[1].apply(this,arguments)){
if((pair[3])||(this.returnWrappers)){
return pair[2];
}else{
return pair[2].apply(this,arguments);
}
}
}
throw new Error("No match found");
},unregister:function(name){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[0]==name){
this.pairs.splice(i,1);
return true;
}
}
return false;
}});
dojo.provide("dojo.json");
dojo.json={jsonRegistry:new dojo.AdapterRegistry(),register:function(name,_3b7,wrap,_3b9){
dojo.json.jsonRegistry.register(name,_3b7,wrap,_3b9);
},evalJson:function(json){
try{
return eval("("+json+")");
}
catch(e){
dojo.debug(e);
return json;
}
},serialize:function(o){
var _3bc=typeof (o);
if(_3bc=="undefined"){
return "undefined";
}else{
if((_3bc=="number")||(_3bc=="boolean")){
return o+"";
}else{
if(o===null){
return "null";
}
}
}
if(_3bc=="string"){
return dojo.string.escapeString(o);
}
var me=arguments.callee;
var _3be;
if(typeof (o.__json__)=="function"){
_3be=o.__json__();
if(o!==_3be){
return me(_3be);
}
}
if(typeof (o.json)=="function"){
_3be=o.json();
if(o!==_3be){
return me(_3be);
}
}
if(_3bc!="function"&&typeof (o.length)=="number"){
var res=[];
for(var i=0;i<o.length;i++){
var val=me(o[i]);
if(typeof (val)!="string"){
val="undefined";
}
res.push(val);
}
return "["+res.join(",")+"]";
}
try{
window.o=o;
_3be=dojo.json.jsonRegistry.match(o);
return me(_3be);
}
catch(e){
}
if(_3bc=="function"){
return null;
}
res=[];
for(var k in o){
var _3c3;
if(typeof (k)=="number"){
_3c3="\""+k+"\"";
}else{
if(typeof (k)=="string"){
_3c3=dojo.string.escapeString(k);
}else{
continue;
}
}
val=me(o[k]);
if(typeof (val)!="string"){
continue;
}
res.push(_3c3+":"+val);
}
return "{"+res.join(",")+"}";
}};
dojo.provide("dojo.html.common");
dojo.lang.mixin(dojo.html,dojo.dom);
dojo.html.body=function(){
dojo.deprecated("dojo.html.body() moved to dojo.body()","0.5");
return dojo.body();
};
dojo.html.getEventTarget=function(evt){
if(!evt){
evt=dojo.global().event||{};
}
var t=(evt.srcElement?evt.srcElement:(evt.target?evt.target:null));
while((t)&&(t.nodeType!=1)){
t=t.parentNode;
}
return t;
};
dojo.html.getViewport=function(){
var _3c6=dojo.global();
var _3c7=dojo.doc();
var w=0;
var h=0;
if(dojo.render.html.mozilla){
w=_3c7.documentElement.clientWidth;
h=_3c6.innerHeight;
}else{
if(!dojo.render.html.opera&&_3c6.innerWidth){
w=_3c6.innerWidth;
h=_3c6.innerHeight;
}else{
if(!dojo.render.html.opera&&dojo.exists(_3c7,"documentElement.clientWidth")){
var w2=_3c7.documentElement.clientWidth;
if(!w||w2&&w2<w){
w=w2;
}
h=_3c7.documentElement.clientHeight;
}else{
if(dojo.body().clientWidth){
w=dojo.body().clientWidth;
h=dojo.body().clientHeight;
}
}
}
}
return {width:w,height:h};
};
dojo.html.getScroll=function(){
var _3cb=dojo.global();
var _3cc=dojo.doc();
var top=_3cb.pageYOffset||_3cc.documentElement.scrollTop||dojo.body().scrollTop||0;
var left=_3cb.pageXOffset||_3cc.documentElement.scrollLeft||dojo.body().scrollLeft||0;
return {top:top,left:left,offset:{x:left,y:top}};
};
dojo.html.getParentByType=function(node,type){
var _3d1=dojo.doc();
var _3d2=dojo.byId(node);
type=type.toLowerCase();
while((_3d2)&&(_3d2.nodeName.toLowerCase()!=type)){
if(_3d2==(_3d1["body"]||_3d1["documentElement"])){
return null;
}
_3d2=_3d2.parentNode;
}
return _3d2;
};
dojo.html.getAttribute=function(node,attr){
node=dojo.byId(node);
if((!node)||(!node.getAttribute)){
return null;
}
var ta=typeof attr=="string"?attr:new String(attr);
var v=node.getAttribute(ta.toUpperCase());
if((v)&&(typeof v=="string")&&(v!="")){
return v;
}
if(v&&v.value){
return v.value;
}
if((node.getAttributeNode)&&(node.getAttributeNode(ta))){
return (node.getAttributeNode(ta)).value;
}else{
if(node.getAttribute(ta)){
return node.getAttribute(ta);
}else{
if(node.getAttribute(ta.toLowerCase())){
return node.getAttribute(ta.toLowerCase());
}
}
}
return null;
};
dojo.html.hasAttribute=function(node,attr){
return dojo.html.getAttribute(dojo.byId(node),attr)?true:false;
};
dojo.html.getCursorPosition=function(e){
e=e||dojo.global().event;
var _3da={x:0,y:0};
if(e.pageX||e.pageY){
_3da.x=e.pageX;
_3da.y=e.pageY;
}else{
var de=dojo.doc().documentElement;
var db=dojo.body();
_3da.x=e.clientX+((de||db)["scrollLeft"])-((de||db)["clientLeft"]);
_3da.y=e.clientY+((de||db)["scrollTop"])-((de||db)["clientTop"]);
}
return _3da;
};
dojo.html.isTag=function(node){
node=dojo.byId(node);
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName.toLowerCase()==String(arguments[i]).toLowerCase()){
return String(arguments[i]).toLowerCase();
}
}
}
return "";
};
if(dojo.render.html.ie&&!dojo.render.html.ie70){
if(window.location.href.substr(0,6).toLowerCase()!="https:"){
(function(){
var _3df=dojo.doc().createElement("script");
_3df.src="javascript:'dojo.html.createExternalElement=function(doc, tag){ return doc.createElement(tag); }'";
dojo.doc().getElementsByTagName("head")[0].appendChild(_3df);
})();
}
}else{
dojo.html.createExternalElement=function(doc,tag){
return doc.createElement(tag);
};
}
dojo.html._callDeprecated=function(_3e2,_3e3,args,_3e5,_3e6){
dojo.deprecated("dojo.html."+_3e2,"replaced by dojo.html."+_3e3+"("+(_3e5?"node, {"+_3e5+": "+_3e5+"}":"")+")"+(_3e6?"."+_3e6:""),"0.5");
var _3e7=[];
if(_3e5){
var _3e8={};
_3e8[_3e5]=args[1];
_3e7.push(args[0]);
_3e7.push(_3e8);
}else{
_3e7=args;
}
var ret=dojo.html[_3e3].apply(dojo.html,args);
if(_3e6){
return ret[_3e6];
}else{
return ret;
}
};
dojo.html.getViewportWidth=function(){
return dojo.html._callDeprecated("getViewportWidth","getViewport",arguments,null,"width");
};
dojo.html.getViewportHeight=function(){
return dojo.html._callDeprecated("getViewportHeight","getViewport",arguments,null,"height");
};
dojo.html.getViewportSize=function(){
return dojo.html._callDeprecated("getViewportSize","getViewport",arguments);
};
dojo.html.getScrollTop=function(){
return dojo.html._callDeprecated("getScrollTop","getScroll",arguments,null,"top");
};
dojo.html.getScrollLeft=function(){
return dojo.html._callDeprecated("getScrollLeft","getScroll",arguments,null,"left");
};
dojo.html.getScrollOffset=function(){
return dojo.html._callDeprecated("getScrollOffset","getScroll",arguments,null,"offset");
};
dojo.provide("dojo.uri.Uri");
dojo.uri=new function(){
this.dojoUri=function(uri){
return new dojo.uri.Uri(dojo.hostenv.getBaseScriptUri(),uri);
};
this.moduleUri=function(_3eb,uri){
var loc=dojo.hostenv.getModulePrefix(_3eb);
if(!loc){
return null;
}
if(loc.lastIndexOf("/")!=loc.length-1){
loc+="/";
}
return new dojo.uri.Uri(dojo.hostenv.getBaseScriptUri()+loc,uri);
};
this.Uri=function(){
var uri=arguments[0];
for(var i=1;i<arguments.length;i++){
if(!arguments[i]){
continue;
}
var _3f0=new dojo.uri.Uri(arguments[i].toString());
var _3f1=new dojo.uri.Uri(uri.toString());
if((_3f0.path=="")&&(_3f0.scheme==null)&&(_3f0.authority==null)&&(_3f0.query==null)){
if(_3f0.fragment!=null){
_3f1.fragment=_3f0.fragment;
}
_3f0=_3f1;
}else{
if(_3f0.scheme==null){
_3f0.scheme=_3f1.scheme;
if(_3f0.authority==null){
_3f0.authority=_3f1.authority;
if(_3f0.path.charAt(0)!="/"){
var path=_3f1.path.substring(0,_3f1.path.lastIndexOf("/")+1)+_3f0.path;
var segs=path.split("/");
for(var j=0;j<segs.length;j++){
if(segs[j]=="."){
if(j==segs.length-1){
segs[j]="";
}else{
segs.splice(j,1);
j--;
}
}else{
if(j>0&&!(j==1&&segs[0]=="")&&segs[j]==".."&&segs[j-1]!=".."){
if(j==segs.length-1){
segs.splice(j,1);
segs[j-1]="";
}else{
segs.splice(j-1,2);
j-=2;
}
}
}
}
_3f0.path=segs.join("/");
}
}
}
}
uri="";
if(_3f0.scheme!=null){
uri+=_3f0.scheme+":";
}
if(_3f0.authority!=null){
uri+="//"+_3f0.authority;
}
uri+=_3f0.path;
if(_3f0.query!=null){
uri+="?"+_3f0.query;
}
if(_3f0.fragment!=null){
uri+="#"+_3f0.fragment;
}
}
this.uri=uri.toString();
var _3f5="^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?$";
var r=this.uri.match(new RegExp(_3f5));
this.scheme=r[2]||(r[1]?"":null);
this.authority=r[4]||(r[3]?"":null);
this.path=r[5];
this.query=r[7]||(r[6]?"":null);
this.fragment=r[9]||(r[8]?"":null);
if(this.authority!=null){
_3f5="^((([^:]+:)?([^@]+))@)?([^:]*)(:([0-9]+))?$";
r=this.authority.match(new RegExp(_3f5));
this.user=r[3]||null;
this.password=r[4]||null;
this.host=r[5];
this.port=r[7]||null;
}
this.toString=function(){
return this.uri;
};
};
};
dojo.provide("dojo.html.style");
dojo.html.getClass=function(node){
node=dojo.byId(node);
if(!node){
return "";
}
var cs="";
if(node.className){
cs=node.className;
}else{
if(dojo.html.hasAttribute(node,"class")){
cs=dojo.html.getAttribute(node,"class");
}
}
return cs.replace(/^\s+|\s+$/g,"");
};
dojo.html.getClasses=function(node){
var c=dojo.html.getClass(node);
return (c=="")?[]:c.split(/\s+/g);
};
dojo.html.hasClass=function(node,_3fc){
return (new RegExp("(^|\\s+)"+_3fc+"(\\s+|$)")).test(dojo.html.getClass(node));
};
dojo.html.prependClass=function(node,_3fe){
_3fe+=" "+dojo.html.getClass(node);
return dojo.html.setClass(node,_3fe);
};
dojo.html.addClass=function(node,_400){
if(dojo.html.hasClass(node,_400)){
return false;
}
_400=(dojo.html.getClass(node)+" "+_400).replace(/^\s+|\s+$/g,"");
return dojo.html.setClass(node,_400);
};
dojo.html.setClass=function(node,_402){
node=dojo.byId(node);
var cs=new String(_402);
try{
if(typeof node.className=="string"){
node.className=cs;
}else{
if(node.setAttribute){
node.setAttribute("class",_402);
node.className=cs;
}else{
return false;
}
}
}
catch(e){
dojo.debug("dojo.html.setClass() failed",e);
}
return true;
};
dojo.html.removeClass=function(node,_405,_406){
try{
if(!_406){
var _407=dojo.html.getClass(node).replace(new RegExp("(^|\\s+)"+_405+"(\\s+|$)"),"$1$2");
}else{
var _407=dojo.html.getClass(node).replace(_405,"");
}
dojo.html.setClass(node,_407);
}
catch(e){
dojo.debug("dojo.html.removeClass() failed",e);
}
return true;
};
dojo.html.replaceClass=function(node,_409,_40a){
dojo.html.removeClass(node,_40a);
dojo.html.addClass(node,_409);
};
dojo.html.classMatchType={ContainsAll:0,ContainsAny:1,IsOnly:2};
dojo.html.getElementsByClass=function(_40b,_40c,_40d,_40e,_40f){
_40f=false;
var _410=dojo.doc();
_40c=dojo.byId(_40c)||_410;
var _411=_40b.split(/\s+/g);
var _412=[];
if(_40e!=1&&_40e!=2){
_40e=0;
}
var _413=new RegExp("(\\s|^)(("+_411.join(")|(")+"))(\\s|$)");
var _414=_411.join(" ").length;
var _415=[];
if(!_40f&&_410.evaluate){
var _416=".//"+(_40d||"*")+"[contains(";
if(_40e!=dojo.html.classMatchType.ContainsAny){
_416+="concat(' ',@class,' '), ' "+_411.join(" ') and contains(concat(' ',@class,' '), ' ")+" ')";
if(_40e==2){
_416+=" and string-length(@class)="+_414+"]";
}else{
_416+="]";
}
}else{
_416+="concat(' ',@class,' '), ' "+_411.join(" ') or contains(concat(' ',@class,' '), ' ")+" ')]";
}
var _417=_410.evaluate(_416,_40c,null,XPathResult.ANY_TYPE,null);
var _418=_417.iterateNext();
while(_418){
try{
_415.push(_418);
_418=_417.iterateNext();
}
catch(e){
break;
}
}
return _415;
}else{
if(!_40d){
_40d="*";
}
_415=_40c.getElementsByTagName(_40d);
var node,i=0;
outer:
while(node=_415[i++]){
var _41b=dojo.html.getClasses(node);
if(_41b.length==0){
continue outer;
}
var _41c=0;
for(var j=0;j<_41b.length;j++){
if(_413.test(_41b[j])){
if(_40e==dojo.html.classMatchType.ContainsAny){
_412.push(node);
continue outer;
}else{
_41c++;
}
}else{
if(_40e==dojo.html.classMatchType.IsOnly){
continue outer;
}
}
}
if(_41c==_411.length){
if((_40e==dojo.html.classMatchType.IsOnly)&&(_41c==_41b.length)){
_412.push(node);
}else{
if(_40e==dojo.html.classMatchType.ContainsAll){
_412.push(node);
}
}
}
}
return _412;
}
};
dojo.html.getElementsByClassName=dojo.html.getElementsByClass;
dojo.html.toCamelCase=function(_41e){
var arr=_41e.split("-"),cc=arr[0];
for(var i=1;i<arr.length;i++){
cc+=arr[i].charAt(0).toUpperCase()+arr[i].substring(1);
}
return cc;
};
dojo.html.toSelectorCase=function(_422){
return _422.replace(/([A-Z])/g,"-$1").toLowerCase();
};
dojo.html.getComputedStyle=function(node,_424,_425){
node=dojo.byId(node);
var _424=dojo.html.toSelectorCase(_424);
var _426=dojo.html.toCamelCase(_424);
if(!node||!node.style){
return _425;
}else{
if(document.defaultView&&dojo.html.isDescendantOf(node,node.ownerDocument)){
try{
var cs=document.defaultView.getComputedStyle(node,"");
if(cs){
return cs.getPropertyValue(_424);
}
}
catch(e){
if(node.style.getPropertyValue){
return node.style.getPropertyValue(_424);
}else{
return _425;
}
}
}else{
if(node.currentStyle){
return node.currentStyle[_426];
}
}
}
if(node.style.getPropertyValue){
return node.style.getPropertyValue(_424);
}else{
return _425;
}
};
dojo.html.getStyleProperty=function(node,_429){
node=dojo.byId(node);
return (node&&node.style?node.style[dojo.html.toCamelCase(_429)]:undefined);
};
dojo.html.getStyle=function(node,_42b){
var _42c=dojo.html.getStyleProperty(node,_42b);
return (_42c?_42c:dojo.html.getComputedStyle(node,_42b));
};
dojo.html.setStyle=function(node,_42e,_42f){
node=dojo.byId(node);
if(node&&node.style){
var _430=dojo.html.toCamelCase(_42e);
node.style[_430]=_42f;
}
};
dojo.html.setStyleText=function(_431,text){
try{
_431.style.cssText=text;
}
catch(e){
_431.setAttribute("style",text);
}
};
dojo.html.copyStyle=function(_433,_434){
if(!_434.style.cssText){
_433.setAttribute("style",_434.getAttribute("style"));
}else{
_433.style.cssText=_434.style.cssText;
}
dojo.html.addClass(_433,dojo.html.getClass(_434));
};
dojo.html.getUnitValue=function(node,_436,_437){
var s=dojo.html.getComputedStyle(node,_436);
if((!s)||((s=="auto")&&(_437))){
return {value:0,units:"px"};
}
var _439=s.match(/(\-?[\d.]+)([a-z%]*)/i);
if(!_439){
return dojo.html.getUnitValue.bad;
}
return {value:Number(_439[1]),units:_439[2].toLowerCase()};
};
dojo.html.getUnitValue.bad={value:NaN,units:""};
dojo.html.getPixelValue=function(node,_43b,_43c){
var _43d=dojo.html.getUnitValue(node,_43b,_43c);
if(isNaN(_43d.value)){
return 0;
}
if((_43d.value)&&(_43d.units!="px")){
return NaN;
}
return _43d.value;
};
dojo.html.setPositivePixelValue=function(node,_43f,_440){
if(isNaN(_440)){
return false;
}
node.style[_43f]=Math.max(0,_440)+"px";
return true;
};
dojo.html.styleSheet=null;
dojo.html.insertCssRule=function(_441,_442,_443){
if(!dojo.html.styleSheet){
if(document.createStyleSheet){
dojo.html.styleSheet=document.createStyleSheet();
}else{
if(document.styleSheets[0]){
dojo.html.styleSheet=document.styleSheets[0];
}else{
return null;
}
}
}
if(arguments.length<3){
if(dojo.html.styleSheet.cssRules){
_443=dojo.html.styleSheet.cssRules.length;
}else{
if(dojo.html.styleSheet.rules){
_443=dojo.html.styleSheet.rules.length;
}else{
return null;
}
}
}
if(dojo.html.styleSheet.insertRule){
var rule=_441+" { "+_442+" }";
return dojo.html.styleSheet.insertRule(rule,_443);
}else{
if(dojo.html.styleSheet.addRule){
return dojo.html.styleSheet.addRule(_441,_442,_443);
}else{
return null;
}
}
};
dojo.html.removeCssRule=function(_445){
if(!dojo.html.styleSheet){
dojo.debug("no stylesheet defined for removing rules");
return false;
}
if(dojo.render.html.ie){
if(!_445){
_445=dojo.html.styleSheet.rules.length;
dojo.html.styleSheet.removeRule(_445);
}
}else{
if(document.styleSheets[0]){
if(!_445){
_445=dojo.html.styleSheet.cssRules.length;
}
dojo.html.styleSheet.deleteRule(_445);
}
}
return true;
};
dojo.html._insertedCssFiles=[];
dojo.html.insertCssFile=function(URI,doc,_448,_449){
if(!URI){
return;
}
if(!doc){
doc=document;
}
var _44a=dojo.hostenv.getText(URI,false,_449);
if(_44a===null){
return;
}
_44a=dojo.html.fixPathsInCssText(_44a,URI);
if(_448){
var idx=-1,node,ent=dojo.html._insertedCssFiles;
for(var i=0;i<ent.length;i++){
if((ent[i].doc==doc)&&(ent[i].cssText==_44a)){
idx=i;
node=ent[i].nodeRef;
break;
}
}
if(node){
var _44f=doc.getElementsByTagName("style");
for(var i=0;i<_44f.length;i++){
if(_44f[i]==node){
return;
}
}
dojo.html._insertedCssFiles.shift(idx,1);
}
}
var _450=dojo.html.insertCssText(_44a);
dojo.html._insertedCssFiles.push({"doc":doc,"cssText":_44a,"nodeRef":_450});
if(_450&&djConfig.isDebug){
_450.setAttribute("dbgHref",URI);
}
return _450;
};
dojo.html.insertCssText=function(_451,doc,URI){
if(!_451){
return;
}
if(!doc){
doc=document;
}
if(URI){
_451=dojo.html.fixPathsInCssText(_451,URI);
}
var _454=doc.createElement("style");
_454.setAttribute("type","text/css");
var head=doc.getElementsByTagName("head")[0];
if(!head){
dojo.debug("No head tag in document, aborting styles");
return;
}else{
head.appendChild(_454);
}
if(_454.styleSheet){
_454.styleSheet.cssText=_451;
}else{
var _456=doc.createTextNode(_451);
_454.appendChild(_456);
}
return _454;
};
dojo.html.fixPathsInCssText=function(_457,URI){
function iefixPathsInCssText(){
var _459=/AlphaImageLoader\(src\=['"]([\t\s\w()\/.\\'"-:#=&?~]*)['"]/;
while(_45a=_459.exec(_457)){
url=_45a[1].replace(_45c,"$2");
if(!_45d.exec(url)){
url=(new dojo.uri.Uri(URI,url).toString());
}
str+=_457.substring(0,_45a.index)+"AlphaImageLoader(src='"+url+"'";
_457=_457.substr(_45a.index+_45a[0].length);
}
return str+_457;
}
if(!_457||!URI){
return;
}
var _45a,str="",url="";
var _45f=/url\(\s*([\t\s\w()\/.\\'"-:#=&?]+)\s*\)/;
var _45d=/(file|https?|ftps?):\/\//;
var _45c=/^[\s]*(['"]?)([\w()\/.\\'"-:#=&?]*)\1[\s]*?$/;
if(dojo.render.html.ie55||dojo.render.html.ie60){
_457=iefixPathsInCssText();
}
while(_45a=_45f.exec(_457)){
url=_45a[1].replace(_45c,"$2");
if(!_45d.exec(url)){
url=(new dojo.uri.Uri(URI,url).toString());
}
str+=_457.substring(0,_45a.index)+"url("+url+")";
_457=_457.substr(_45a.index+_45a[0].length);
}
return str+_457;
};
dojo.html.setActiveStyleSheet=function(_460){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")){
a.disabled=true;
if(a.getAttribute("title")==_460){
a.disabled=false;
}
}
}
};
dojo.html.getActiveStyleSheet=function(){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")&&!a.disabled){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.getPreferredStyleSheet=function(){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("rel").indexOf("alt")==-1&&a.getAttribute("title")){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.applyBrowserClass=function(node){
var drh=dojo.render.html;
var _46c={dj_ie:drh.ie,dj_ie55:drh.ie55,dj_ie6:drh.ie60,dj_ie7:drh.ie70,dj_iequirks:drh.ie&&drh.quirks,dj_opera:drh.opera,dj_opera8:drh.opera&&(Math.floor(dojo.render.version)==8),dj_opera9:drh.opera&&(Math.floor(dojo.render.version)==9),dj_khtml:drh.khtml,dj_safari:drh.safari,dj_gecko:drh.mozilla};
for(var p in _46c){
if(_46c[p]){
dojo.html.addClass(node,p);
}
}
};
dojo.provide("dojo.html.*");
dojo.provide("dojo.html.display");
dojo.html._toggle=function(node,_46f,_470){
node=dojo.byId(node);
_470(node,!_46f(node));
return _46f(node);
};
dojo.html.show=function(node){
node=dojo.byId(node);
if(dojo.html.getStyleProperty(node,"display")=="none"){
dojo.html.setStyle(node,"display",(node.dojoDisplayCache||""));
node.dojoDisplayCache=undefined;
}
};
dojo.html.hide=function(node){
node=dojo.byId(node);
if(typeof node["dojoDisplayCache"]=="undefined"){
var d=dojo.html.getStyleProperty(node,"display");
if(d!="none"){
node.dojoDisplayCache=d;
}
}
dojo.html.setStyle(node,"display","none");
};
dojo.html.setShowing=function(node,_475){
dojo.html[(_475?"show":"hide")](node);
};
dojo.html.isShowing=function(node){
return (dojo.html.getStyleProperty(node,"display")!="none");
};
dojo.html.toggleShowing=function(node){
return dojo.html._toggle(node,dojo.html.isShowing,dojo.html.setShowing);
};
dojo.html.displayMap={tr:"",td:"",th:"",img:"inline",span:"inline",input:"inline",button:"inline"};
dojo.html.suggestDisplayByTagName=function(node){
node=dojo.byId(node);
if(node&&node.tagName){
var tag=node.tagName.toLowerCase();
return (tag in dojo.html.displayMap?dojo.html.displayMap[tag]:"block");
}
};
dojo.html.setDisplay=function(node,_47b){
dojo.html.setStyle(node,"display",((_47b instanceof String||typeof _47b=="string")?_47b:(_47b?dojo.html.suggestDisplayByTagName(node):"none")));
};
dojo.html.isDisplayed=function(node){
return (dojo.html.getComputedStyle(node,"display")!="none");
};
dojo.html.toggleDisplay=function(node){
return dojo.html._toggle(node,dojo.html.isDisplayed,dojo.html.setDisplay);
};
dojo.html.setVisibility=function(node,_47f){
dojo.html.setStyle(node,"visibility",((_47f instanceof String||typeof _47f=="string")?_47f:(_47f?"visible":"hidden")));
};
dojo.html.isVisible=function(node){
return (dojo.html.getComputedStyle(node,"visibility")!="hidden");
};
dojo.html.toggleVisibility=function(node){
return dojo.html._toggle(node,dojo.html.isVisible,dojo.html.setVisibility);
};
dojo.html.setOpacity=function(node,_483,_484){
node=dojo.byId(node);
var h=dojo.render.html;
if(!_484){
if(_483>=1){
if(h.ie){
dojo.html.clearOpacity(node);
return;
}else{
_483=0.999999;
}
}else{
if(_483<0){
_483=0;
}
}
}
if(h.ie){
if(node.nodeName.toLowerCase()=="tr"){
var tds=node.getElementsByTagName("td");
for(var x=0;x<tds.length;x++){
tds[x].style.filter="Alpha(Opacity="+_483*100+")";
}
}
node.style.filter="Alpha(Opacity="+_483*100+")";
}else{
if(h.moz){
node.style.opacity=_483;
node.style.MozOpacity=_483;
}else{
if(h.safari){
node.style.opacity=_483;
node.style.KhtmlOpacity=_483;
}else{
node.style.opacity=_483;
}
}
}
};
dojo.html.clearOpacity=function(node){
node=dojo.byId(node);
var ns=node.style;
var h=dojo.render.html;
if(h.ie){
try{
if(node.filters&&node.filters.alpha){
ns.filter="";
}
}
catch(e){
}
}else{
if(h.moz){
ns.opacity=1;
ns.MozOpacity=1;
}else{
if(h.safari){
ns.opacity=1;
ns.KhtmlOpacity=1;
}else{
ns.opacity=1;
}
}
}
};
dojo.html.getOpacity=function(node){
node=dojo.byId(node);
var h=dojo.render.html;
if(h.ie){
var opac=(node.filters&&node.filters.alpha&&typeof node.filters.alpha.opacity=="number"?node.filters.alpha.opacity:100)/100;
}else{
var opac=node.style.opacity||node.style.MozOpacity||node.style.KhtmlOpacity||1;
}
return opac>=0.999999?1:Number(opac);
};
dojo.provide("dojo.html.layout");
dojo.html.sumAncestorProperties=function(node,prop){
node=dojo.byId(node);
if(!node){
return 0;
}
var _490=0;
while(node){
if(dojo.html.getComputedStyle(node,"position")=="fixed"){
return 0;
}
var val=node[prop];
if(val){
_490+=val-0;
if(node==dojo.body()){
break;
}
}
node=node.parentNode;
}
return _490;
};
dojo.html.setStyleAttributes=function(node,_493){
node=dojo.byId(node);
var _494=_493.replace(/(;)?\s*$/,"").split(";");
for(var i=0;i<_494.length;i++){
var _496=_494[i].split(":");
var name=_496[0].replace(/\s*$/,"").replace(/^\s*/,"").toLowerCase();
var _498=_496[1].replace(/\s*$/,"").replace(/^\s*/,"");
switch(name){
case "opacity":
dojo.html.setOpacity(node,_498);
break;
case "content-height":
dojo.html.setContentBox(node,{height:_498});
break;
case "content-width":
dojo.html.setContentBox(node,{width:_498});
break;
case "outer-height":
dojo.html.setMarginBox(node,{height:_498});
break;
case "outer-width":
dojo.html.setMarginBox(node,{width:_498});
break;
default:
node.style[dojo.html.toCamelCase(name)]=_498;
}
}
};
dojo.html.boxSizing={MARGIN_BOX:"margin-box",BORDER_BOX:"border-box",PADDING_BOX:"padding-box",CONTENT_BOX:"content-box"};
dojo.html.getAbsolutePosition=dojo.html.abs=function(node,_49a,_49b){
node=dojo.byId(node,node.ownerDocument);
var ret={x:0,y:0};
var bs=dojo.html.boxSizing;
if(!_49b){
_49b=bs.CONTENT_BOX;
}
var _49e=2;
var _49f;
switch(_49b){
case bs.MARGIN_BOX:
_49f=3;
break;
case bs.BORDER_BOX:
_49f=2;
break;
case bs.PADDING_BOX:
default:
_49f=1;
break;
case bs.CONTENT_BOX:
_49f=0;
break;
}
var h=dojo.render.html;
var db=document["body"]||document["documentElement"];
if(h.ie){
with(node.getBoundingClientRect()){
ret.x=left-2;
ret.y=top-2;
}
}else{
if(document.getBoxObjectFor){
_49e=1;
try{
var bo=document.getBoxObjectFor(node);
ret.x=bo.x-dojo.html.sumAncestorProperties(node,"scrollLeft");
ret.y=bo.y-dojo.html.sumAncestorProperties(node,"scrollTop");
}
catch(e){
}
}else{
if(node["offsetParent"]){
var _4a3;
if((h.safari)&&(node.style.getPropertyValue("position")=="absolute")&&(node.parentNode==db)){
_4a3=db;
}else{
_4a3=db.parentNode;
}
if(node.parentNode!=db){
var nd=node;
if(dojo.render.html.opera){
nd=db;
}
ret.x-=dojo.html.sumAncestorProperties(nd,"scrollLeft");
ret.y-=dojo.html.sumAncestorProperties(nd,"scrollTop");
}
var _4a5=node;
do{
var n=_4a5["offsetLeft"];
if(!h.opera||n>0){
ret.x+=isNaN(n)?0:n;
}
var m=_4a5["offsetTop"];
ret.y+=isNaN(m)?0:m;
_4a5=_4a5.offsetParent;
}while((_4a5!=_4a3)&&(_4a5!=null));
}else{
if(node["x"]&&node["y"]){
ret.x+=isNaN(node.x)?0:node.x;
ret.y+=isNaN(node.y)?0:node.y;
}
}
}
}
if(_49a){
var _4a8=dojo.html.getScroll();
ret.y+=_4a8.top;
ret.x+=_4a8.left;
}
var _4a9=[dojo.html.getPaddingExtent,dojo.html.getBorderExtent,dojo.html.getMarginExtent];
if(_49e>_49f){
for(var i=_49f;i<_49e;++i){
ret.y+=_4a9[i](node,"top");
ret.x+=_4a9[i](node,"left");
}
}else{
if(_49e<_49f){
for(var i=_49f;i>_49e;--i){
ret.y-=_4a9[i-1](node,"top");
ret.x-=_4a9[i-1](node,"left");
}
}
}
ret.top=ret.y;
ret.left=ret.x;
return ret;
};
dojo.html.isPositionAbsolute=function(node){
return (dojo.html.getComputedStyle(node,"position")=="absolute");
};
dojo.html._sumPixelValues=function(node,_4ad,_4ae){
var _4af=0;
for(var x=0;x<_4ad.length;x++){
_4af+=dojo.html.getPixelValue(node,_4ad[x],_4ae);
}
return _4af;
};
dojo.html.getMargin=function(node){
return {width:dojo.html._sumPixelValues(node,["margin-left","margin-right"],(dojo.html.getComputedStyle(node,"position")=="absolute")),height:dojo.html._sumPixelValues(node,["margin-top","margin-bottom"],(dojo.html.getComputedStyle(node,"position")=="absolute"))};
};
dojo.html.getBorder=function(node){
return {width:dojo.html.getBorderExtent(node,"left")+dojo.html.getBorderExtent(node,"right"),height:dojo.html.getBorderExtent(node,"top")+dojo.html.getBorderExtent(node,"bottom")};
};
dojo.html.getBorderExtent=function(node,side){
return (dojo.html.getStyle(node,"border-"+side+"-style")=="none"?0:dojo.html.getPixelValue(node,"border-"+side+"-width"));
};
dojo.html.getMarginExtent=function(node,side){
return dojo.html._sumPixelValues(node,["margin-"+side],dojo.html.isPositionAbsolute(node));
};
dojo.html.getPaddingExtent=function(node,side){
return dojo.html._sumPixelValues(node,["padding-"+side],true);
};
dojo.html.getPadding=function(node){
return {width:dojo.html._sumPixelValues(node,["padding-left","padding-right"],true),height:dojo.html._sumPixelValues(node,["padding-top","padding-bottom"],true)};
};
dojo.html.getPadBorder=function(node){
var pad=dojo.html.getPadding(node);
var _4bc=dojo.html.getBorder(node);
return {width:pad.width+_4bc.width,height:pad.height+_4bc.height};
};
dojo.html.getBoxSizing=function(node){
var h=dojo.render.html;
var bs=dojo.html.boxSizing;
if((h.ie)||(h.opera)){
var cm=document["compatMode"];
if((cm=="BackCompat")||(cm=="QuirksMode")){
return bs.BORDER_BOX;
}else{
return bs.CONTENT_BOX;
}
}else{
if(arguments.length==0){
node=document.documentElement;
}
var _4c1=dojo.html.getStyle(node,"-moz-box-sizing");
if(!_4c1){
_4c1=dojo.html.getStyle(node,"box-sizing");
}
return (_4c1?_4c1:bs.CONTENT_BOX);
}
};
dojo.html.isBorderBox=function(node){
return (dojo.html.getBoxSizing(node)==dojo.html.boxSizing.BORDER_BOX);
};
dojo.html.getBorderBox=function(node){
node=dojo.byId(node);
return {width:node.offsetWidth,height:node.offsetHeight};
};
dojo.html.getPaddingBox=function(node){
var box=dojo.html.getBorderBox(node);
var _4c6=dojo.html.getBorder(node);
return {width:box.width-_4c6.width,height:box.height-_4c6.height};
};
dojo.html.getContentBox=function(node){
node=dojo.byId(node);
var _4c8=dojo.html.getPadBorder(node);
return {width:node.offsetWidth-_4c8.width,height:node.offsetHeight-_4c8.height};
};
dojo.html.setContentBox=function(node,args){
node=dojo.byId(node);
var _4cb=0;
var _4cc=0;
var isbb=dojo.html.isBorderBox(node);
var _4ce=(isbb?dojo.html.getPadBorder(node):{width:0,height:0});
var ret={};
if(typeof args.width!="undefined"){
_4cb=args.width+_4ce.width;
ret.width=dojo.html.setPositivePixelValue(node,"width",_4cb);
}
if(typeof args.height!="undefined"){
_4cc=args.height+_4ce.height;
ret.height=dojo.html.setPositivePixelValue(node,"height",_4cc);
}
return ret;
};
dojo.html.getMarginBox=function(node){
var _4d1=dojo.html.getBorderBox(node);
var _4d2=dojo.html.getMargin(node);
return {width:_4d1.width+_4d2.width,height:_4d1.height+_4d2.height};
};
dojo.html.setMarginBox=function(node,args){
node=dojo.byId(node);
var _4d5=0;
var _4d6=0;
var isbb=dojo.html.isBorderBox(node);
var _4d8=(!isbb?dojo.html.getPadBorder(node):{width:0,height:0});
var _4d9=dojo.html.getMargin(node);
var ret={};
if(typeof args.width!="undefined"){
_4d5=args.width-_4d8.width;
_4d5-=_4d9.width;
ret.width=dojo.html.setPositivePixelValue(node,"width",_4d5);
}
if(typeof args.height!="undefined"){
_4d6=args.height-_4d8.height;
_4d6-=_4d9.height;
ret.height=dojo.html.setPositivePixelValue(node,"height",_4d6);
}
return ret;
};
dojo.html.getElementBox=function(node,type){
var bs=dojo.html.boxSizing;
switch(type){
case bs.MARGIN_BOX:
return dojo.html.getMarginBox(node);
case bs.BORDER_BOX:
return dojo.html.getBorderBox(node);
case bs.PADDING_BOX:
return dojo.html.getPaddingBox(node);
case bs.CONTENT_BOX:
default:
return dojo.html.getContentBox(node);
}
};
dojo.html.toCoordinateObject=dojo.html.toCoordinateArray=function(_4de,_4df,_4e0){
if(_4de instanceof Array||typeof _4de=="array"){
dojo.deprecated("dojo.html.toCoordinateArray","use dojo.html.toCoordinateObject({left: , top: , width: , height: }) instead","0.5");
while(_4de.length<4){
_4de.push(0);
}
while(_4de.length>4){
_4de.pop();
}
var ret={left:_4de[0],top:_4de[1],width:_4de[2],height:_4de[3]};
}else{
if(!_4de.nodeType&&!(_4de instanceof String||typeof _4de=="string")&&("width" in _4de||"height" in _4de||"left" in _4de||"x" in _4de||"top" in _4de||"y" in _4de)){
var ret={left:_4de.left||_4de.x||0,top:_4de.top||_4de.y||0,width:_4de.width||0,height:_4de.height||0};
}else{
var node=dojo.byId(_4de);
var pos=dojo.html.abs(node,_4df,_4e0);
var _4e4=dojo.html.getMarginBox(node);
var ret={left:pos.left,top:pos.top,width:_4e4.width,height:_4e4.height};
}
}
ret.x=ret.left;
ret.y=ret.top;
return ret;
};
dojo.html.setMarginBoxWidth=dojo.html.setOuterWidth=function(node,_4e6){
return dojo.html._callDeprecated("setMarginBoxWidth","setMarginBox",arguments,"width");
};
dojo.html.setMarginBoxHeight=dojo.html.setOuterHeight=function(){
return dojo.html._callDeprecated("setMarginBoxHeight","setMarginBox",arguments,"height");
};
dojo.html.getMarginBoxWidth=dojo.html.getOuterWidth=function(){
return dojo.html._callDeprecated("getMarginBoxWidth","getMarginBox",arguments,null,"width");
};
dojo.html.getMarginBoxHeight=dojo.html.getOuterHeight=function(){
return dojo.html._callDeprecated("getMarginBoxHeight","getMarginBox",arguments,null,"height");
};
dojo.html.getTotalOffset=function(node,type,_4e9){
return dojo.html._callDeprecated("getTotalOffset","getAbsolutePosition",arguments,null,type);
};
dojo.html.getAbsoluteX=function(node,_4eb){
return dojo.html._callDeprecated("getAbsoluteX","getAbsolutePosition",arguments,null,"x");
};
dojo.html.getAbsoluteY=function(node,_4ed){
return dojo.html._callDeprecated("getAbsoluteY","getAbsolutePosition",arguments,null,"y");
};
dojo.html.totalOffsetLeft=function(node,_4ef){
return dojo.html._callDeprecated("totalOffsetLeft","getAbsolutePosition",arguments,null,"left");
};
dojo.html.totalOffsetTop=function(node,_4f1){
return dojo.html._callDeprecated("totalOffsetTop","getAbsolutePosition",arguments,null,"top");
};
dojo.html.getMarginWidth=function(node){
return dojo.html._callDeprecated("getMarginWidth","getMargin",arguments,null,"width");
};
dojo.html.getMarginHeight=function(node){
return dojo.html._callDeprecated("getMarginHeight","getMargin",arguments,null,"height");
};
dojo.html.getBorderWidth=function(node){
return dojo.html._callDeprecated("getBorderWidth","getBorder",arguments,null,"width");
};
dojo.html.getBorderHeight=function(node){
return dojo.html._callDeprecated("getBorderHeight","getBorder",arguments,null,"height");
};
dojo.html.getPaddingWidth=function(node){
return dojo.html._callDeprecated("getPaddingWidth","getPadding",arguments,null,"width");
};
dojo.html.getPaddingHeight=function(node){
return dojo.html._callDeprecated("getPaddingHeight","getPadding",arguments,null,"height");
};
dojo.html.getPadBorderWidth=function(node){
return dojo.html._callDeprecated("getPadBorderWidth","getPadBorder",arguments,null,"width");
};
dojo.html.getPadBorderHeight=function(node){
return dojo.html._callDeprecated("getPadBorderHeight","getPadBorder",arguments,null,"height");
};
dojo.html.getBorderBoxWidth=dojo.html.getInnerWidth=function(){
return dojo.html._callDeprecated("getBorderBoxWidth","getBorderBox",arguments,null,"width");
};
dojo.html.getBorderBoxHeight=dojo.html.getInnerHeight=function(){
return dojo.html._callDeprecated("getBorderBoxHeight","getBorderBox",arguments,null,"height");
};
dojo.html.getContentBoxWidth=dojo.html.getContentWidth=function(){
return dojo.html._callDeprecated("getContentBoxWidth","getContentBox",arguments,null,"width");
};
dojo.html.getContentBoxHeight=dojo.html.getContentHeight=function(){
return dojo.html._callDeprecated("getContentBoxHeight","getContentBox",arguments,null,"height");
};
dojo.html.setContentBoxWidth=dojo.html.setContentWidth=function(node,_4fb){
return dojo.html._callDeprecated("setContentBoxWidth","setContentBox",arguments,"width");
};
dojo.html.setContentBoxHeight=dojo.html.setContentHeight=function(node,_4fd){
return dojo.html._callDeprecated("setContentBoxHeight","setContentBox",arguments,"height");
};
dojo.provide("dojo.html.util");
dojo.html.getElementWindow=function(_4fe){
return dojo.html.getDocumentWindow(_4fe.ownerDocument);
};
dojo.html.getDocumentWindow=function(doc){
if(dojo.render.html.safari&&!doc._parentWindow){
var fix=function(win){
win.document._parentWindow=win;
for(var i=0;i<win.frames.length;i++){
fix(win.frames[i]);
}
};
fix(window.top);
}
if(dojo.render.html.ie&&window!==document.parentWindow&&!doc._parentWindow){
doc.parentWindow.execScript("document._parentWindow = window;","Javascript");
var win=doc._parentWindow;
doc._parentWindow=null;
return win;
}
return doc._parentWindow||doc.parentWindow||doc.defaultView;
};
dojo.html.gravity=function(node,e){
node=dojo.byId(node);
var _506=dojo.html.getCursorPosition(e);
with(dojo.html){
var _507=getAbsolutePosition(node,true);
var bb=getBorderBox(node);
var _509=_507.x+(bb.width/2);
var _50a=_507.y+(bb.height/2);
}
with(dojo.html.gravity){
return ((_506.x<_509?WEST:EAST)|(_506.y<_50a?NORTH:SOUTH));
}
};
dojo.html.gravity.NORTH=1;
dojo.html.gravity.SOUTH=1<<1;
dojo.html.gravity.EAST=1<<2;
dojo.html.gravity.WEST=1<<3;
dojo.html.overElement=function(_50b,e){
_50b=dojo.byId(_50b);
var _50d=dojo.html.getCursorPosition(e);
var bb=dojo.html.getBorderBox(_50b);
var _50f=dojo.html.getAbsolutePosition(_50b,true,dojo.html.boxSizing.BORDER_BOX);
var top=_50f.y;
var _511=top+bb.height;
var left=_50f.x;
var _513=left+bb.width;
return (_50d.x>=left&&_50d.x<=_513&&_50d.y>=top&&_50d.y<=_511);
};
dojo.html.renderedTextContent=function(node){
node=dojo.byId(node);
var _515="";
if(node==null){
return _515;
}
for(var i=0;i<node.childNodes.length;i++){
switch(node.childNodes[i].nodeType){
case 1:
case 5:
var _517="unknown";
try{
_517=dojo.html.getStyle(node.childNodes[i],"display");
}
catch(E){
}
switch(_517){
case "block":
case "list-item":
case "run-in":
case "table":
case "table-row-group":
case "table-header-group":
case "table-footer-group":
case "table-row":
case "table-column-group":
case "table-column":
case "table-cell":
case "table-caption":
_515+="\n";
_515+=dojo.html.renderedTextContent(node.childNodes[i]);
_515+="\n";
break;
case "none":
break;
default:
if(node.childNodes[i].tagName&&node.childNodes[i].tagName.toLowerCase()=="br"){
_515+="\n";
}else{
_515+=dojo.html.renderedTextContent(node.childNodes[i]);
}
break;
}
break;
case 3:
case 2:
case 4:
var text=node.childNodes[i].nodeValue;
var _519="unknown";
try{
_519=dojo.html.getStyle(node,"text-transform");
}
catch(E){
}
switch(_519){
case "capitalize":
var _51a=text.split(" ");
for(var i=0;i<_51a.length;i++){
_51a[i]=_51a[i].charAt(0).toUpperCase()+_51a[i].substring(1);
}
text=_51a.join(" ");
break;
case "uppercase":
text=text.toUpperCase();
break;
case "lowercase":
text=text.toLowerCase();
break;
default:
break;
}
switch(_519){
case "nowrap":
break;
case "pre-wrap":
break;
case "pre-line":
break;
case "pre":
break;
default:
text=text.replace(/\s+/," ");
if(/\s$/.test(_515)){
text.replace(/^\s/,"");
}
break;
}
_515+=text;
break;
default:
break;
}
}
return _515;
};
dojo.html.createNodesFromText=function(txt,trim){
if(trim){
txt=txt.replace(/^\s+|\s+$/g,"");
}
var tn=dojo.doc().createElement("div");
tn.style.visibility="hidden";
dojo.body().appendChild(tn);
var _51e="none";
if((/^<t[dh][\s\r\n>]/i).test(txt.replace(/^\s+/))){
txt="<table><tbody><tr>"+txt+"</tr></tbody></table>";
_51e="cell";
}else{
if((/^<tr[\s\r\n>]/i).test(txt.replace(/^\s+/))){
txt="<table><tbody>"+txt+"</tbody></table>";
_51e="row";
}else{
if((/^<(thead|tbody|tfoot)[\s\r\n>]/i).test(txt.replace(/^\s+/))){
txt="<table>"+txt+"</table>";
_51e="section";
}
}
}
tn.innerHTML=txt;
if(tn["normalize"]){
tn.normalize();
}
var _51f=null;
switch(_51e){
case "cell":
_51f=tn.getElementsByTagName("tr")[0];
break;
case "row":
_51f=tn.getElementsByTagName("tbody")[0];
break;
case "section":
_51f=tn.getElementsByTagName("table")[0];
break;
default:
_51f=tn;
break;
}
var _520=[];
for(var x=0;x<_51f.childNodes.length;x++){
_520.push(_51f.childNodes[x].cloneNode(true));
}
tn.style.display="none";
dojo.body().removeChild(tn);
return _520;
};
dojo.html.placeOnScreen=function(node,_523,_524,_525,_526,_527,_528){
if(_523 instanceof Array||typeof _523=="array"){
_528=_527;
_527=_526;
_526=_525;
_525=_524;
_524=_523[1];
_523=_523[0];
}
if(_527 instanceof String||typeof _527=="string"){
_527=_527.split(",");
}
if(!isNaN(_525)){
_525=[Number(_525),Number(_525)];
}else{
if(!(_525 instanceof Array||typeof _525=="array")){
_525=[0,0];
}
}
var _529=dojo.html.getScroll().offset;
var view=dojo.html.getViewport();
node=dojo.byId(node);
var _52b=node.style.display;
node.style.display="";
var bb=dojo.html.getBorderBox(node);
var w=bb.width;
var h=bb.height;
node.style.display=_52b;
if(!(_527 instanceof Array||typeof _527=="array")){
_527=["TL"];
}
var _52f,_530,_531=Infinity,_532;
for(var _533=0;_533<_527.length;++_533){
var _534=_527[_533];
var _535=true;
var tryX=_523-(_534.charAt(1)=="L"?0:w)+_525[0]*(_534.charAt(1)=="L"?1:-1);
var tryY=_524-(_534.charAt(0)=="T"?0:h)+_525[1]*(_534.charAt(0)=="T"?1:-1);
if(_526){
tryX-=_529.x;
tryY-=_529.y;
}
if(tryX<0){
tryX=0;
_535=false;
}
if(tryY<0){
tryY=0;
_535=false;
}
var x=tryX+w;
if(x>view.width){
x=view.width-w;
_535=false;
}else{
x=tryX;
}
x=Math.max(_525[0],x)+_529.x;
var y=tryY+h;
if(y>view.height){
y=view.height-h;
_535=false;
}else{
y=tryY;
}
y=Math.max(_525[1],y)+_529.y;
if(_535){
_52f=x;
_530=y;
_531=0;
_532=_534;
break;
}else{
var dist=Math.pow(x-tryX-_529.x,2)+Math.pow(y-tryY-_529.y,2);
if(_531>dist){
_531=dist;
_52f=x;
_530=y;
_532=_534;
}
}
}
if(!_528){
node.style.left=_52f+"px";
node.style.top=_530+"px";
}
return {left:_52f,top:_530,x:_52f,y:_530,dist:_531,corner:_532};
};
dojo.html.placeOnScreenPoint=function(node,_53c,_53d,_53e,_53f){
dojo.deprecated("dojo.html.placeOnScreenPoint","use dojo.html.placeOnScreen() instead","0.5");
return dojo.html.placeOnScreen(node,_53c,_53d,_53e,_53f,["TL","TR","BL","BR"]);
};
dojo.html.placeOnScreenAroundElement=function(node,_541,_542,_543,_544,_545){
var best,_547=Infinity;
_541=dojo.byId(_541);
var _548=_541.style.display;
_541.style.display="";
var mb=dojo.html.getElementBox(_541,_543);
var _54a=mb.width;
var _54b=mb.height;
var _54c=dojo.html.getAbsolutePosition(_541,true,_543);
_541.style.display=_548;
for(var _54d in _544){
var pos,_54f,_550;
var _551=_544[_54d];
_54f=_54c.x+(_54d.charAt(1)=="L"?0:_54a);
_550=_54c.y+(_54d.charAt(0)=="T"?0:_54b);
pos=dojo.html.placeOnScreen(node,_54f,_550,_542,true,_551,true);
if(pos.dist==0){
best=pos;
break;
}else{
if(_547>pos.dist){
_547=pos.dist;
best=pos;
}
}
}
if(!_545){
node.style.left=best.left+"px";
node.style.top=best.top+"px";
}
return best;
};
dojo.html.scrollIntoView=function(node){
if(!node){
return;
}
if(dojo.render.html.ie){
if(dojo.html.getBorderBox(node.parentNode).height<node.parentNode.scrollHeight){
node.scrollIntoView(false);
}
}else{
if(dojo.render.html.mozilla){
node.scrollIntoView(false);
}else{
var _553=node.parentNode;
var _554=_553.scrollTop+dojo.html.getBorderBox(_553).height;
var _555=node.offsetTop+dojo.html.getMarginBox(node).height;
if(_554<_555){
_553.scrollTop+=(_555-_554);
}else{
if(_553.scrollTop>node.offsetTop){
_553.scrollTop-=(_553.scrollTop-node.offsetTop);
}
}
}
}
};

